-*- coding: utf-8 -*-

base-url = https://github.com/ruby/ruby

commit c04363c0a09d1e9cd03ff2e5cf6dd83e87a8a90c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2026-01-06 07:08:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2026-01-06 07:08:17 +0900

    Remove k0kubun from CODEOWNERS

    nagachika will take over the maintenance of ruby_3_4 going forward.

commit 2bf88ac15dec2588caf543215036bcf2cb0b485a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-12 10:45:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-17 09:36:22 +0900

    make-snapshot: Fix Psych::DisallowedClass with newer psych

    ```
    $ tool/format-release ../www.ruby-lang.org 4.0.0-preview2 .
    /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/class_loader.rb:99:in 'Psych::ClassLoader::Restricted#find': Tried to load unspecified class: Date (Psych::DisallowedClass)
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/class_loader.rb:28:in 'Psych::ClassLoader#load'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/class_loader.rb:40:in 'Psych::ClassLoader#date'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/scalar_scanner.rb:65:in 'Psych::ScalarScanner#tokenize'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:65:in 'Psych::Visitors::ToRuby#deserialize'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:129:in 'Psych::Visitors::ToRuby#visit_Psych_Nodes_Scalar'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:30:in 'Psych::Visitors::Visitor#visit'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:6:in 'Psych::Visitors::Visitor#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:35:in 'Psych::Visitors::ToRuby#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:346:in 'block in Psych::Visitors::ToRuby#revive_hash'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:344:in 'Array#each'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:344:in 'Enumerable#each_slice'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:344:in 'Psych::Visitors::ToRuby#revive_hash'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:168:in 'Psych::Visitors::ToRuby#visit_Psych_Nodes_Mapping'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:30:in 'Psych::Visitors::Visitor#visit'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:6:in 'Psych::Visitors::Visitor#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:35:in 'Psych::Visitors::ToRuby#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:339:in 'block in Psych::Visitors::ToRuby#register_empty'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:339:in 'Array#each'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:339:in 'Psych::Visitors::ToRuby#register_empty'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:147:in 'Psych::Visitors::ToRuby#visit_Psych_Nodes_Sequence'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:30:in 'Psych::Visitors::Visitor#visit'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:6:in 'Psych::Visitors::Visitor#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:35:in 'Psych::Visitors::ToRuby#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:319:in 'Psych::Visitors::ToRuby#visit_Psych_Nodes_Document'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:30:in 'Psych::Visitors::Visitor#visit'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/visitor.rb:6:in 'Psych::Visitors::Visitor#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych/visitors/to_ruby.rb:35:in 'Psych::Visitors::ToRuby#accept'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych.rb:336:in 'Psych.safe_load'
            from /opt/rubies/3.4.6/lib/ruby/3.4.0/psych.rb:371:in 'Psych.load'
            from tool/format-release:80:in 'Tarball.parse'
            from tool/format-release:269:in 'Object#main'
            from tool/format-release:272:in '<main>'
    ```

commit 995b59f66677d44767ce9faac6957e5543617ff9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-17 08:56:55 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-17 08:56:55 +0900

    v3.4.8

commit d8f087b581735ec250b8671c3574fa4d5b16ae54
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-17 08:53:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-17 08:53:40 +0900

    merge revision(s) 9168cad4d63a5d281d443bde4edea6be213b0b25: [Backport #21266]

            [PATCH] YJIT: Bail out if proc would be stored above stack top

            Fixes [Bug #21266].

commit 252b718582baf5760a6db2efdb58b84a0bf3f47f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-17 08:53:03 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-17 08:53:03 +0900

    merge revision(s) bc2a8a002a6c41fc1b28e02e15e2fb2b72d1b66e, c26057ebafb23b063190d31d5b4d19a0e0a1306c: [Backport #21779]

            [PATCH] [Bug #21779] Uniquify `InitVM` functions as well as `Init`

            Avoid possible name conflict when `--with-static-linked-ext`.

            [PATCH] [Bug #21779] Do not export InitVM functions

            Fix ruby/io-console#105.

commit 7edff469e14541a480a6156efc1cc6e3b526e7bd
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-17 08:51:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-17 08:51:44 +0900

    merge revision(s) 1e7cf7b2bc1f9b356b2e980e1e18548618da6363: [Backport #21446]

            [PATCH] Fix refinement modification of method visibility in superclass

            Previously, this didn't work correctly, resulting in a
            SystemStackError. This fixes the issue by finding the related
            superclass method entry, and updating the orig_me in the
            refinement method to point to the superclass method.

            Fixes [Bug #21446]

commit 70a7c551fcead48f5964fbc7a0bd20cc50b635c0
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-17 03:33:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-17 04:55:31 +0900

    YJIT: Print `Rc` strong and weak count on assert failure

    For <https://bugs.ruby-lang.org/issues/21716>, the panic is looking like
    some sort of third party memory corruption, with YJIT taking the fall.
    At the point of this assert, the assembler has dropped, so there's
    nothing in YJIT's code other than JITState that could be holding on to
    these transient `PendingBranchRef`.

    The strong count being more than a handful or the weak count is non-zero
    shows that someone in the process (likely some native extension)
    corrupted the Rc's counts.

commit f19e9c6699150d56853ba1a33f6149d7588c8478
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-13 08:00:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-13 08:43:41 +0900

    YJIT: Fix panic from overly loose filtering in identity method inlining

    Credits to @rwstauner for noticing this issue in GH-15533.

commit 628a94104768b294ae8068c7bb39ab9e495fdd94
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-12-13 03:42:00 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-13 08:43:41 +0900

    YJIT: Add missing local variable type update for fallback setlocal blocks

    Previously, the chain_depth>0 version of setlocal blocks did not
    update the type of the local variable in the context. This can leave
    the context with stale type information and trigger or lead to miscompilation.

    To trigger the issue, YJIT needs to see the same ISEQ before and after
    environment escape and have tracked type info before the escape. To
    trigger in ISEQs that do not send with a block, it probably requires
    Kernel#binding or the use of include/ruby/debug.h APIs.

    [Backport #21772]

commit 88f1d98676d435a79e2086ed8054b459f1b4bd2a
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-12-03 10:34:36 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-13 01:56:50 +0900

    Fix allocationless anonymous splat keyword argument check

    Previously, if an argument splat and keywords are provided by
    the caller, it did not check whether the method/proc accepted
    keywords before avoiding the allocation. This is incorrect,
    because if the method/proc does not accept keywords, the
    keywords passed by the caller are added as a positional
    argument, so there must be an allocation to avoid mutating
    the positional splat argument.

    Add a check that if the caller passes keywords, the
    method/proc must accept keywords in order to optimize.
    If the caller passes a keyword splat, either the
    method/proc must accept keywords, or the keyword splat must
    be empty in order to optimize.

    If keywords are explicitly disallowed via `**nil`, the
    optimization should be skipped, because the array is mutated
    before the ArgumentError exception is raised.

    In addition to a test for the correct behavior, add an
    allocation test for a method that accepts an anonymous splat
    without keywords.

    Fixes [Bug #21757]

commit 6dc27d14a0427da7b28a6884578009a9740f69fd
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-10-02 03:25:26 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-09 08:30:35 +0900

    Interpolation with only string literals must not be frozen

    Basically a redo of https://github.com/ruby/ruby/commit/a1403fb7cbd1fe0df97c932be9814c86081783dc
    but respecting the frozen string literal magic comment

    Fixes [Bug #21187]

commit bc40e758307c9be3e39497b5010fbaceb14bf8c7
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2025-07-22 09:13:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-09 08:30:35 +0900

    Interpolated strings must not be frozen

    Strings concatenated with backslash may end up being frozen when they
    shouldn't be.  This commit fixes the issue.  It required a change
    upstream in Prism, but also a change to the Prism compiler in CRuby.

      https://github.com/ruby/prism/pull/3606

    [Bug #21187]

commit d282e76fb6c9f56ac44b3abfc8a3fc9f10edd6f0
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-09 07:56:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-09 08:30:35 +0900

    Bump Prism to v1.5.2

    [Backport #21187]

commit d0b778cd19fdda858121d8f2405da2768603c9b1
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-09 08:03:34 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-09 08:03:34 +0900

    merge revision(s) 0b0da6c4b26f80ad6985722d3fc0f5cdee09125d: [Backport #21648]

            [PATCH] Correctly compile splats in for-loop index in prism

            Fixes [Bug #21648]

            This is a followup to https://github.com/ruby/ruby/pull/13597.
            The added test passed but didn't emit the same instructions.

            This also handles bare splats and aligns instructions for all cases

commit 955decc1da6cd2441c24d22e8909a3e995973769
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-09 07:46:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-09 07:46:06 +0900

    merge revision(s) beb85e7eeee4163cd45b69645a60cdb942f72c05: [Backport #21705]

            [PATCH] [Bug #21705] Fix segfaults on Windows

            It should check the type of the argument and coercion before
            converting the encoding.

commit fe8221af30768cbd15409d4cc52b2bb18e91667e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-09 07:44:48 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-09 07:44:48 +0900

    merge revision(s) f4f728b319086eea3db6e9909fb9c849c276f813: [Backport #21680]

            [PATCH] [Bug #21680] Fix (base**power_of_two).digits(base) bug (#15144)

            Fix wrong condition in base multiplying loop.

commit 625eeae0db2749e62152d8a750706eff24a271d0
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-09 07:38:24 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-09 07:38:24 +0900

    merge revision(s) a4dff09be79b52288a47658964d25e5aa84fc960: [Backport #21265]

            [PATCH] [Bug #21673] Fix resolving refined module-defined method

            A method defined in a module has no `defined_class`, use the ICLASS
            for it as the `defined_class`.

commit da66b64a18414d5ece52512eb016c1af2ede1730
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-09 07:36:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-09 07:36:06 +0900

    merge revision(s) 9d44cb0b2b5520b2b299851003ca2a97bf1e2079, 367ddd445cdf5ccc55a0481c944746ef595f72f7, 48dce7874fcb571765635b32fa6a3e3a12e228f8: [Backport #21655]

            [PATCH] Remove rbimpl_rstring_getmem() usage as workaround for GCC 15.2.1 optimization bug. [Bug #21655]

            [PATCH] include/ruby/internal/core/rstring.h: Remove rbimpl_rstring_getmem() definition.

            [PATCH] simplify RSRING_GETMEM() definition.

commit 1adfd3ec401e7a09e1e3e61708592b202a3f8277
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-09 07:29:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-09 07:29:57 +0900

    merge revision(s) c5bd4acd30320a8e180ce9fcb24acdab4e10c73a: [Backport #21666]

            [PATCH] [Bug #21666] Get rid of use of unspecified values

commit a2ba1478e8c6a810c0fa08695a48f95ef5c29c45
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-09 07:24:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-09 07:24:18 +0900

    merge revision(s) 190b017fc6c21ff7b61c2b5ece0294785e4a4ca2: [Backport #21703]

            [PATCH] Don't use non blocking pipes for RUBY_CRASH_REPORT

            [Bug #21703]

            RUBY_CRASH_REPORT does not work in some cases when shelling out on Linux.
            For example, given the following shell script dump.sh:

                #!/usr/bin/env bash
                cat > /tmp/crash

            And we see it fails like this:

                $ RUBY_CRASH_REPORT="|dump.sh" ruby -rfiddle -e "Fiddle::Pointer.new(1, 10)[0]"
                cat: -: Resource temporarily unavailable

commit ef2d4bf51bf28cfc427388a19e4a5fe9bbbe7a7a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-12-09 07:21:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-09 07:21:06 +0900

    merge revision(s) 6e6f5d3c32a709c891ac6aa7833376907a6c81b5: [Backport #21265]

            [PATCH] Add test for [Bug #21265]

            The crash was fixed by a4dff09be79b52288a47658964d25e5aa84fc960 ("Fix
            resolving refined module-defined method"). I had a patch for this around
            for a few months but never merged it. Oops!

commit e4abacc53396865e20c226a7ac8ed8b86267874b
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2025-12-04 14:29:35 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-05 01:56:13 +0900

    Ractor.store_if_absent should not warn

    ```ruby
    $VERBOSE = true

    Ractor.store_if_absent :key do
    end #=> warning: the block passed to 'Ractor.store_if_absent' defined at <internal:ractor>:474 may be ignored
    ```

commit dd0dfecc361d3306ff674b5adcf81c0b1d7ee25d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-12-03 14:37:29 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-04 01:52:43 +0900

    Next Ruby version is 4.0, not 3.5

commit 28b2e2ede97b569c2f6121e7808975fbd5c6f298
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2025-11-26 11:29:02 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-12-02 02:45:35 +0900

    YJIT: Abort expandarray optimization if method_missing is defined

    Fixes: [Bug #21707]
    [AW: rewrote comments]
    Co-authored-by: Alan Wu <alanwu@ruby-lang.org>

commit 3b09e559da73e63ff25156fcb9e892948c7b2afb
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-02 02:44:46 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-12-02 02:44:46 +0900

    vm_cc_new: don't assume `cme` is present. (#15322)

    [Bug #21694]

    `vm_search_super_method` explictly calls `vm_cc_new` with `cme=NULL`
    when there is no super class.

commit 7482835d0b5c9f55662fb7c6586f456354e2b66e
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-08-20 11:13:00 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-11-18 06:28:01 +0900

    Avoid spawning thread for trivial getnameinfo calls

    When calling getnameinfo we spawn a thread because it may do a slow,
    blocking reverse-DNS lookup. Spawning a thread is relatively fast (~20µs
    on my Linux machine) but still an order of magnitude slower than when
    getnameinfo is simply translating to a numeric IP or port, which, at
    least in my tests on Linux, doesn't even make a syscall.

    This commit adds a fast path for when reverse DNS isn't required: either
    host isn't being fetched or NI_NUMERICHOST is set AND either the
    service name isn't required or NI_NUMERICSERV is set. The service name
    should only need to read /etc/services, which should be fast-ish, but
    is still I/O so I kept the existing behaviour (it could be on a network
    fs I guess).

    I tested with:

        s = TCPSocket.open("www.ruby-lang.org", 80)
        500_000.times { Socket.unpack_sockaddr_in(s.getpeername) }

    Before: 12.935s
    After: 0.338s

commit 9e4829699b544370dd3a83df3e2c6b9168c34159
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-11-15 04:48:40 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-11-15 04:48:40 +0900

    ext/socket: Set raddrinfo thread as detached before thread start (#15194)

    Backport of https://github.com/ruby/ruby/pull/15142

    [Bug #21679]

commit 0b559eab0447905a784092824e5ea0999018cd01
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-11-14 05:01:55 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-11-15 03:07:34 +0900

    YJIT: Fix stack handling in rb_str_dup

    Previously because we did a stack_push before ccall, in some cases we
    could end up pushing an uninitialized value to the VM stack when
    spilling regs as part of the ccall.

    Co-authored-by: Luke Gruber <luke.gru@gmail.com>

commit 3f6cdb1246025388ab5be3da0be2dc4c5a1a5178
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-11-13 04:02:23 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-11-13 04:02:23 +0900

    Update next stable version to 4.0 from 3.5 (#15146)

commit e4b1f77dec69bcc7c1a5d082716bee5441f1d485
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-11-07 21:57:24 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-11-11 07:38:19 +0900

    Use `IO.popen` instead of `IO.foreach` with pipe

commit 9e426489f00a1b7816e8c6f299daa6116c5f505d
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-11-08 12:44:56 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-11-08 12:44:56 +0900

    Don't modify fstrings in rb_str_tmp_frozen_no_embed_acquire (#15104)

    [Bug #21671]

commit a7eba5453934e778c5911a4b69d9c3b8fdf31a23
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-10-28 21:55:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-11-07 03:25:54 +0900

    [Backport #21625] Allow io/wait methods with `IO#ungetc` in text mode

commit 3150a1d989d81089c7da7d0491321e370e71f482
  Author:     K.Takata <kentkt@csc.jp>
  AuthorDate: 2019-01-25 18:54:41 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-11-07 03:25:26 +0900

    [Backport #13671] Fix that "ss" in look-behind causes syntax error

    Fixes k-takata/Onigmo#92.

    This fix was ported from oniguruma:
    https://github.com/kkos/oniguruma/commit/257082dac8c6019198b56324012f0bd1830ff4ba

    https://github.com/k-takata/Onigmo/commit/b1a5445fbeba97b3e94a733c2ce11c033453af73

commit badb3600093ed5df2c64bc257b5cb3a149a88189
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-11-07 01:26:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-11-07 03:24:37 +0900

    merge revision(s) d17ce4bd05dc05d48f5f4bc75171fcebda1678ed: [Backport #21652]

            [PATCH] [Bug #21652] [DOC] Update unmarshalable object list

            The `Data` mentioned here was the old `T_DATA` class, not the current
            extended `Struct`.

commit f2fd5b3bc23bce7527192057d4b4b11fa179170f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-10-14 12:38:52 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-11-07 03:23:58 +0900

    [Backport #21638] Mark ractor-local `$VERBOSE` and `$DEBUG`

    https://github.com/sampersand/blog/blob/master/the%20-s%20flag.md#the-segfault

commit c26a2b12e1f7f0779f2e86f59a405b1913cf72c8
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-11-05 15:10:54 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-11-05 15:10:54 +0900

    merge revision(s) 377aa2a336cc700485c699ac49330f2a58b74906: [Backport #21668]

            [PATCH] Improve performance of UnicodeNormalize.canonical_ordering_one

            Use array_of_integer.sort! instead of buble-sort-like algorithm

commit 7ec94afa8faad31d8b973edc53347973062e4d20
  Author:     Andre Muta <andremuta@gmail.com>
  AuthorDate: 2025-10-30 12:55:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-11-02 00:51:57 +0900

    mn timer thread: force wakeups for timeouts

commit 0b7ea9c7953803a56622c62139404473a4115565
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-10-02 12:53:48 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-30 08:35:14 +0900

    YJIT: Prevent making a branch from a dead block to a live block

    I'm seeing some memory corruption in the wild on blocks in
    `IseqPayload::dead_blocks`. While I unfortunately can't recreate the
    issue, (For all I know, it could be some external code corrupting YJIT's
    memory.) establishing a link between dead blocks and live blocks seems
    fishy enough that we ought to prevent it. When it did happen, it might've
    had bad interacts with Code GC and the optimization to immediately
    free empty blocks.

commit 75ae7093a9b61b06a26770241c6d545c4b3d94e3
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-10-23 08:22:43 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-23 11:57:28 +0900

    [ruby/rubygems] Removed credential assertion from stdout

    https://github.com/ruby/rubygems/commit/3946be008c

commit 7fa4d58ef28f701d6ac7475fd34cd69c32b554a1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-10-23 07:54:45 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-23 11:57:28 +0900

    [ruby/rubygems] Bump up vendored uri to 1.0.4

    https://github.com/ruby/rubygems/commit/bc77ec0bf2

commit 3afa38d0ee34a453d7c53d4512a8f14d25d23f57
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-08-14 01:39:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-23 05:53:20 +0900

    YJIT: Fix `defined?(yield)` and `block_given?` at top level

    Previously, YJIT returned truthy for the block given query at the top
    level. That's incorrect because the top level script never receives a
    block, and `yield` is a syntax error there.

    Inside methods, the number of hops to get from `iseq` to
    `iseq->body->local_iseq` is the same as the number of
    `VM_ENV_PREV_EP(ep)` hops to get to an environment with
    `VM_ENV_FLAG_LOCAL`. YJIT and the interpreter both rely on this as can
    be seen in get_lvar_level(). However, this identity does not hold for
    the top level frame because of `vm_set_eval_stack()`, which sets up
    `TOPLEVEL_BINDING`.

    Since only methods can take a block that `yield` goes to, have ISEQs
    that are the child of a non-method ISEQ return falsy for the block given
    query. This fixes the issue for the top level script and is an
    optimization for non-method contexts such as inside `ISEQ_TYPE_CLASS`.

commit 5d2a244bfd844be3a94670ddcb509fb5a6b4e847
  Author:     viralpraxis <viralpraxis@evilmartians.com>
  AuthorDate: 2025-10-20 03:55:45 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-21 01:24:12 +0900

    [Bug #21644] compile.c: fix `newrange` INSN peephole optimization for chilled string

    ref: https://bugs.ruby-lang.org/issues/21644

    ```shell
    $ ruby -v -e '("a" || "b").."c"'
    ruby 3.4.7 (2025-10-08 revision 7a5688e2a2) +PRISM [x86_64-linux]
    -e:1: warning: possibly useless use of .. in void context
    -e:1: [BUG] Stack consistency error (sp: 7, bp: 6)
    ruby 3.4.7 (2025-10-08 revision 7a5688e2a2) +PRISM [x86_64-linux]

    -- Control frame information -----------------------------------------------
    c:0002 p:0013 s:0007 e:000005 EVAL   -e:1 [FINISH]
    c:0001 p:0000 s:0003 E:001920 DUMMY  [FINISH]

    -- Ruby level backtrace information ----------------------------------------
    -e:1:in '<main>'

    -- Threading information ---------------------------------------------------
    Total ractor count: 1
    Ruby thread count for this ractor: 1

    -- C level backtrace information -------------------------------------------
    ruby/3.4.7/lib/libruby.so.3.4(rb_print_backtrace+0x8) [0x78aa9573c882] /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/vm_dump.c:823
    ruby/3.4.7/lib/libruby.so.3.4(rb_vm_bugreport) /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/vm_dump.c:1155
    ruby/3.4.7/lib/libruby.so.3.4(rb_bug_without_die_internal+0x6b) [0x78aa9544c62f] /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/error.c:1097
    ruby/3.4.7/lib/libruby.so.3.4(rb_bug) /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/error.c:1115
    ruby/3.4.7/lib/libruby.so.3.4(vm_stack_consistency_error+0x1f) [0x78aa9544f091] /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/vm_insnhelper.c:6523
    ruby/3.4.7/lib/libruby.so.3.4(vm_get_cref) /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/insns.def:1134
    ruby/3.4.7/lib/libruby.so.3.4(vm_setclassvariable) /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/vm_insnhelper.c:1630
    ruby/3.4.7/lib/libruby.so.3.4(vm_setclassvariable) /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/vm_insnhelper.c:1627
    ruby/3.4.7/lib/libruby.so.3.4(vm_exec_core) /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/insns.def:253
    ruby/3.4.7/lib/libruby.so.3.4(vm_exec_loop+0xa) [0x78aa95724959] /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/vm.c:2622
    ruby/3.4.7/lib/libruby.so.3.4(rb_vm_exec) /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/vm.c:2598
    ruby/3.4.7/lib/libruby.so.3.4(rb_ec_exec_node+0xa5) [0x78aa95525695] /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/eval.c:281
    ruby/3.4.7/lib/libruby.so.3.4(ruby_run_node+0x83) [0x78aa95529333] /tmp/ruby-build.20251010151551.31019.jR04SY/ruby-3.4.7/eval.c:319
    ruby/3.4.7/bin/ruby(rb_main+0x21) [0x59d86f5e0186] ./main.c:43
    ruby/3.4.7/bin/ruby(main) ./main.c:68
    /lib/x86_64-linux-gnu/libc.so.6(__libc_start_call_main+0x7a) [0x78aa9502a1ca] ../sysdeps/nptl/libc_start_call_main.h:58
    /lib/x86_64-linux-gnu/libc.so.6(call_init+0x0) [0x78aa9502a28b] ../csu/libc-start.c:360
    /lib/x86_64-linux-gnu/libc.so.6(__libc_start_main_impl) ../csu/libc-start.c:347
    /lib/x86_64-linux-gnu/libc.so.6(__libc_start_main) (null):0
    [0x59d86f5e01d5]
    ```

    The optimization in question:

    https://github.com/ruby/ruby/blob/957c832db137e67289e93dfd9fd9e915b1f2fc87/compile.c\#L3453-L3480

    Before entering the `newrange` optimization, the iseq looks like this:

    ```
    == disasm: #<ISeq:<compiled>@<compiled>:1 (1,0)-(1,17)>
    0000 putchilledstring                       "a"                       (   1)[Li]
    0002 dup
    0003 branchif                               8
    0005 pop
    0006 putchilledstring                       "b"
    0008 putchilledstring                       "c"
    0010 newrange                               0
    0012 leave
    ```

    So the optimization constructs a new range using the wrong operands (`"b"` and `"c"` instead of `"a"` and `"c"`).

    I tried to fix this by checking whether the two previous instructions are labeled.

commit a841c313c50e7ebf74df6e940334c34c68145270
  Author:     Bo Anderson <mail@boanderson.me>
  AuthorDate: 2025-10-09 23:33:54 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-09 23:33:54 +0900

    Update rexml to 3.4.4 for Ruby 3.4 (CVE-2025-58767) (#14795)

    Update rexml to 3.4.4

    [Backport #21632]

commit fce44db5eb7baf1ddd2238254c3cf617fcfd1112
  Author:     Bo Anderson <mail@boanderson.me>
  AuthorDate: 2025-10-09 23:32:47 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-09 23:32:47 +0900

    Update openssl gem to 3.3.1 for Ruby 3.4 (#14792)

    Update openssl gem to 3.3.1

    [Backport #21631]

commit 17877eb2481977a415dd6e51ffe0a9103d575ce7
  Author:     刘皓 <whiteaxe@tuta.io>
  AuthorDate: 2025-10-09 23:30:42 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-09 23:30:42 +0900

    Backport WASI setjmp handler memory leak fixes to Ruby 3.4 (#14788)

    [Bug #21626]

commit 18e176659e8afe402cab7d39972f2d56f2cf378f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-10-09 08:50:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-09 08:50:58 +0900

    merge revision(s) 2bb6fe3854e2a4854bb89bfce4eaaea9d848fd1b: [Backport #21629]

            [PATCH] [Bug #21629] Initialize `struct RString`

    which appears to be missed in the previous commit for some reason.

commit 846bb760756a3bf1ab12d56d8909e104f16e6940
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-10-09 08:45:24 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-09 08:45:24 +0900

    merge revision(s) bbf1130f918ca26e33aba4711ccf99a8083517ea, 43dbb9a93f4de3f1170d7d18641c30e81cc08365, 2bb6fe3854e2a4854bb89bfce4eaaea9d848fd1b, 7c9dd0ecff61153b96473c6c51d5582e809da489: [Backport #21629]

            [PATCH] Add `RBIMPL_ATTR_NONSTRING_ARRAY()` macro for GCC 15

            [PATCH] [Bug #21629] Enable `nonstring` attribute on clang 21

            [PATCH] [Bug #21629] Initialize `struct RString`

            [PATCH] [Bug #21629] Initialize `struct RArray`

commit 9b5d6505ef0fbb27417a5b8face120dec73bacf2
  Author:     Takashi Kokubun <takashi.kokubun@shopify.com>
  AuthorDate: 2025-10-09 06:19:19 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-09 06:19:19 +0900

    post_push.yml: Backport commit-mail to ruby_3_4 (#14781)

commit a0937ff3c780ad870ab398bfc98f2e301fd98b9d
  Author:     Takashi Kokubun <takashi.kokubun@shopify.com>
  AuthorDate: 2025-10-08 17:07:37 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-08 17:07:37 +0900

    Backport fetch_changesets to ruby_3_4 (#14772)

commit 6809d1a002bf70cca22a6763646245fda0ff9070
  Author:     Takashi Kokubun <takashi.kokubun@shopify.com>
  AuthorDate: 2025-10-08 13:19:06 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-10-08 13:19:06 +0900

    Backport post_push.yml workflow to ruby_3_4 (#14769)

commit 7a5688e2a27668e48f8d6ff4af5b2208b98a2f5e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-10-08 01:42:48 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-08 01:42:48 +0900

    v3.4.7

commit ef3ce711fb29f7273216edb2fe41bb2604c835c3
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-10-08 01:41:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-08 01:41:15 +0900

    merge revision(s) 7ae67e8f6ad6e7fd0677b28a7a10961f79d55495: [Backport #21568]

            [PATCH] load.c: Fix dest and src of MEMMOVE

            When multiple files with the same name are required, the features_index
            hash stores the indexes in `$LOADED_FEATURES` array into a darray.
            The dest and src arguments for `MEMMOVE` were wrongly reversed when
            inserting a new index in the darray.

            [Bug #21568]

commit a7eb7e7c6fe02f7127ff527fff18a0914a7aa888
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-10-07 02:53:24 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-08 01:40:55 +0900

    tool/merger.rb: Fetch diff from GitHub instead of cgit

    Our cgit server has been shut down.

    tool/merger.rb: Fetch a diff in the patch format

    It expects "Subject:", so it needs to be a patch file.

commit d2cd7eaa11f57f81cdbacf0e8d5162d37e28337b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-10-07 10:30:16 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-08 01:15:46 +0900

    Update rubyspec as of CVE-2025-27221

commit 71462666e0f1ea720062e12f97b2ea89166038d1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-10-07 18:29:36 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-08 01:15:46 +0900

    Merge URI-1.0.4

commit 49d7295fc38583abf3018a16a2018667871d9f3d
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-10-03 02:05:27 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-10-03 02:05:39 +0900

    macos.yml: macOS 13 hosted runner image is closing down

    https://github.blog/changelog/2025-09-19-github-actions-macos-13-runner-image-is-closing-down/

commit 264b2d78c366491834c9ce4499a4ad7b7564b89d
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-30 07:10:37 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-30 07:10:58 +0900

    Reapply "merge revision(s) 62430c19c9f1ab49429cebe65f30588472648c95: [Backport #21342]"

    This reverts commit c414b9871f263331cde0af1c08cf5c1a47e1aedf.

commit c414b9871f263331cde0af1c08cf5c1a47e1aedf
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-30 07:08:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-30 07:08:47 +0900

    Revert "merge revision(s) 62430c19c9f1ab49429cebe65f30588472648c95: [Backport #21342]"

    This reverts commit 4306c9048fb674d24b92dc46b6746a4749564147.

commit 22c2262b83224f6798d60d539f1f8609d9722766
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-30 06:36:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-30 06:36:06 +0900

    merge revision(s) 354d47ae5bc4edcc94db4a5391ed71a8b9844e57: [Backport #21569]

            IBF: Avoid unaligned load on 32 bit platforms

            [Bug #21569]

commit 4306c9048fb674d24b92dc46b6746a4749564147
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-30 06:35:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-30 06:35:15 +0900

    merge revision(s) 62430c19c9f1ab49429cebe65f30588472648c95: [Backport #21342]

            Properly unlock locked mutexes on thread cleanup.

            Mutexes were being improperly unlocked on thread cleanup. This bug was
            introduced in 050a8954395.

            We must keep a reference from the mutex to the thread, because if the fiber
            is collected before the mutex is, then we cannot unlink it from the thread in
            `mutex_free`. If it's not unlinked from the the thread when it's freed, it
            causes bugs in `rb_thread_unlock_all_locking_mutexes`.

            We now mark the fiber when a mutex is locked, and the thread is marked
            as well. However, a fiber can still be freed in the same GC cycle as the
            mutex, so the reference to the thread is still needed.

            The reason we need to mark the fiber is that `mutex_owned_p()` has an ABA
            issue where if the fiber is collected while it's locked, a new fiber could be
            allocated at the same memory address and we could get false positives.

            Fixes [Bug #21342]

            Co-authored-by: John Hawthorn <john@hawthorn.email>

commit 88a96147a21900a2c22d3ae84d05cd3f6ee795c7
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-30 06:31:05 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-30 06:31:05 +0900

    merge revision(s) ef2b26cc3eaed06c5c9d4ef2c6d8669ff357afa4: [Backport #21611]

            `struct iseq_catch_table` is packed

commit e900e9fc9ace5e36de5170c83df0f56167e4c8a9
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-09-18 12:24:02 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-09-18 12:24:02 +0900

    Use `ec->interrupt_mask` to prevent interrupts. [Backport #21610]

    Disallow pending interrupts to be checked during `FiberScheduler#unblock`.

    Ractors can send signals at any time, so the previous debug assertion can fail if a Ractor sends a signal.

    Co-authored-by: Luke Gruber <luke.gruber@shopify.com>

commit 6882012473b3bd3a9eb53ad7f7754144c0e63ef0
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-09-17 06:17:51 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-09-17 06:17:51 +0900

    [3.4] compile.c: Handle anonymous variables in `outer_variable_cmp` (#13493)

commit b5346f2c5be00f886c9ad2f4b807deb728265a0a
  Author:     Nick Dower <nicholasdower@gmail.com>
  AuthorDate: 2025-05-16 22:44:45 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-17 05:36:08 +0900

    Add a test case for `it` in a regex.

    Co-authored-by: Alan Wu <XrXr@users.noreply.github.com>

commit 1f6d845011cf8900c0e9c6fe5e4243a63a5ecae3
  Author:     Nick Dower <nicholasdower@gmail.com>
  AuthorDate: 2025-05-16 12:18:28 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-17 05:36:08 +0900

    [Bug #21313] Handle `it` in rescue and ensure blocks.

    The following is crashing for me:

    ```shell
    ruby --yjit --yjit-call-threshold=1 -e '1.tap { raise rescue p it }'

    ruby: YJIT has panicked. More info to follow...
    thread '<unnamed>' panicked at ./yjit/src/codegen.rs:2402:14:
    ...
    ```

    It seems `it` sometimes points to the wrong value:

    ```shell
    ruby -e '1.tap { raise rescue p it }'
    false

    ruby -e '1.tap { begin; raise; ensure; p it; end } rescue nil'
    false
    ```

    But only when `$!` is set:

    ```shell
    ruby -e '1.tap { begin; nil; ensure; p it; end }'
    1

    ruby -e '1.tap { begin; nil; rescue; ensure; p it; end }'
    1

    ruby -e '1.tap { begin; raise; rescue; ensure; p it; end }'
    1
    ```

commit dbd83256b1cec76c69756ecb8758b9e1079833de
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-16 07:38:23 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-16 07:38:23 +0900

    v3.4.6

commit 9c65da014548a141137e7e692699b129e3bc655f
  Author:     Takashi Kokubun <takashi.kokubun@shopify.com>
  AuthorDate: 2025-09-14 12:53:54 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-09-14 12:53:54 +0900

    Bump Prism version to 1.5.1 (#14549)

commit 09c067014fa27ad91d310de6a64b7a4443d7da0c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-13 07:22:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-13 07:24:16 +0900

    Attempt to fix [Backport #21567]

commit 21709a58682b9fef53e3e3dec97a0fe4498334e3
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-13 06:58:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-13 06:58:07 +0900

    merge revision(s) 7a05dbc47831a655a1ef8a1635f88292acd325da: [Backport #21561]

            File.dirname: return consistent encoding for `"."`

            [Bug #21561]

            It's preferable if the method is consistent in the encoding in
            the returned string.

commit 00fa53d0ba9ad3c70b634834ff4ca35c2923a894
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-13 06:56:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-13 06:56:47 +0900

    merge revision(s) 928fea3bfa86053c0bc6f7a5bf7559b115a676b5: [Backport #21567]

            Fix crash when $LOADED_FEATURES is modified during require

            [Bug #21567]

            When we require an object that is not a string, it will attempt to convert
            it to a string by calling to_str on it. If we modify the $LOADED_FEATURES
            array while it calls to_str, Ruby can crash because it can end up inserting
            the string in the wrong index in the array.

            For example, the following script crashes:

                require "tempfile"

                class MyString
                  def initialize(path)
                    @path = path
                  end

                  def to_str
                    $LOADED_FEATURES.clear
                    @path
                  end

                  def to_path = @path
                end

                def create_ruby_file = Tempfile.create(["test", ".rb"]).path

                require MyString.new(create_ruby_file)
                $LOADED_FEATURES.unshift(create_ruby_file)
                $LOADED_FEATURES << MyString.new(create_ruby_file)
                require create_ruby_file

            Crash log:

                test.rb:21: [BUG] Segmentation fault at 0x0000000000000004
                ruby 3.5.0dev (2025-09-09T09:29:35Z master ce94add7fb) +PRISM [arm64-darwin24]

                -- Crash Report log information --------------------------------------------
                  See Crash Report log file in one of the following locations:
                    * ~/Library/Logs/DiagnosticReports
                    * /Library/Logs/DiagnosticReports
                  for more details.
                Don't forget to include the above Crash Report log file in bug reports.

                -- Control frame information -----------------------------------------------
                c:0003 p:---- s:0011 e:000010 CFUNC  :require
                c:0002 p:0076 s:0006 e:000005 EVAL   test.rb:21 [FINISH]
                c:0001 p:0000 s:0003 E:0001b0 DUMMY  [FINISH]

                -- Ruby level backtrace information ----------------------------------------
                test.rb:21:in '<main>'
                test.rb:21:in 'require'

                -- Threading information ---------------------------------------------------
                Total ractor count: 1
                Ruby thread count for this ractor: 1

                -- Machine register context ------------------------------------------------
                  x0: 0x0000000000000004  x1: 0x000000000000c800  x2: 0x0000000000000000
                  x3: 0x0000000000000000  x4: 0x0000000000000205  x5: 0x0000000000000000
                  x6: 0x0000000000000000  x7: 0x0000000000000001 x18: 0x0000000000000000
                x19: 0x0000000209dfc0b0 x20: 0x0000000209dfc018 x21: 0x000000016ee8ab58
                x22: 0x0fffffff0009d71d x23: 0x0000000209dfc018 x24: 0x0000000209dfc150
                x25: 0x000000016ee8acc0 x26: 0x0000000000000000 x27: 0x0000000000000000
                x28: 0x0000000000000000  lr: 0x0000000101244140  fp: 0x000000016ee887f0
                  sp: 0x000000016ee887d0

                -- C level backtrace information -------------------------------------------
                miniruby(rb_print_backtrace+0x24) [0x101317b08] vm_dump.c:843
                miniruby(rb_print_backtrace) (null):0
                miniruby(rb_vm_bugreport+0x26c) [0x101317d94] vm_dump.c:1175
                miniruby(rb_bug_for_fatal_signal+0xa4) [0x10105ddac] error.c:1130
                miniruby(sig_do_nothing+0x0) [0x1012278c0] signal.c:948
                miniruby(sigsegv) (null):0
                /usr/lib/system/libsystem_platform.dylib(_sigtramp+0x38) [0x19c1216a4]
                miniruby(rb_str_new_frozen+0x1c) [0x101244140] string.c:1495
                miniruby(rb_check_realpath_internal+0x68) [0x101077804] file.c:4679
                miniruby(rb_check_realpath+0x2c) [0x101077aa4] file.c:4765
                miniruby(get_loaded_features_index+0x37c) [0x1010f9c94] load.c:467
                miniruby(rb_feature_p+0xd0) [0x1010f8174] load.c:582
                miniruby(search_required+0xac) [0x1010f6ad4] load.c:1193
                miniruby(require_internal+0x274) [0x1010f7518] load.c:1424
                miniruby(rb_require_string_internal+0x94) [0x1010f6830] load.c:1571
                miniruby(rb_require_string+0x58) [0x1010f66e8] load.c:1557
                miniruby(rb_f_require+0x1c) [0x1010f6684] load.c:1150
                miniruby(ractor_safe_call_cfunc_1+0x38) [0x101306c28] vm_insnhelper.c:3696
                miniruby(vm_call_cfunc_with_frame_+0x250) [0x1012f857c] vm_insnhelper.c:3873
                miniruby(vm_call_cfunc_with_frame+0x6c) [0x1012f8834] vm_insnhelper.c:3919
                miniruby(vm_sendish+0x1a8) [0x1012c990c] vm_insnhelper.c:6087
                miniruby(vm_exec_core+0x4050) [0x1012cfb48] insns.def:900
                miniruby(vm_exec_loop+0x80) [0x1012e5448] vm.c:2666
                miniruby(rb_vm_exec+0x134) [0x1012c9b40] vm.c:2645
                miniruby(rb_iseq_eval_main+0x34) [0x1012e5628] vm.c:2919
                miniruby(rb_ec_exec_node+0xe4) [0x10106d094] eval.c:282
                miniruby(ruby_run_node+0x94) [0x10106cf64] eval.c:320
                miniruby(rb_main+0x40) [0x100f7499c] main.c:42
                miniruby(main+0x60) [0x100f74928] main.c:62

commit cdd1de636bfa7790c72949d01e4a083845781d87
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-22 09:06:02 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-13 06:30:16 +0900

    Revert "[ruby/prism] Clear flags on interpolated strings"

    This reverts commit a495e6a44ce8cff17461b250e32ab63e409a642d.

    This break extension builds:

    ```
    /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:321:in 'String#replace': can't modify frozen String: "$(SDKROOT)$(prefix)/include" (FrozenError)
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:321:in 'RbConfig.expand'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:314:in 'block in RbConfig.expand'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:307:in 'String#gsub'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:307:in 'RbConfig.expand'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:314:in 'block in RbConfig.expand'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:307:in 'String#gsub'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:307:in 'RbConfig.expand'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:314:in 'block in RbConfig.expand'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:307:in 'String#gsub'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:307:in 'RbConfig.expand'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:325:in 'block in <module:RbConfig>'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:324:in 'Hash#each_value'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:324:in '<module:RbConfig>'
            from /Users/hsbt/Documents/github.com/ruby/ruby/rbconfig.rb:11:in '<top (required)>'
            from ./ext/extmk.rb:42:in 'Kernel#require'
            from ./ext/extmk.rb:42:in '<main>'
    make[1]: *** [ext/configure-ext.mk:70: ext/json/exts.mk] Error 1
    ```

commit c63d6bee7b1bba0308e72cb8d54538ff84af612a
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2025-09-13 05:49:35 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-13 06:30:16 +0900

    Explicitly use a ruby version for prism to parse the code as

    Prism can parse multiple versions of ruby. Because of that branch release managers are ok with simply
    bumping prism to its latest version.

    However, if no version is specified, it will parse as the latest known version, which can be ahead of the maintenance branch.
    So we need to explicitly pass a version to not accidentally introduce new syntax to maintenance branches.

commit 52b3f006cb31672c45b26f6a44a609fd1b8e2ee5
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-13 05:09:30 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-13 06:30:16 +0900

    Bump Prism version to 1.5.0

commit 9cd1ac404e72587952d019df167e7793924699d6
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-09-11 06:02:21 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-11 07:35:06 +0900

    YJIT: Print more disassembly in release builds

    These `#[cfg(feature = "disasm")]` were unnecessary and we can provide
    the information like ruby source location regardless of the availability
    of capstone.

commit c866b9027b7429b402ed272ebaebb6c7831e3cb5
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-09-11 06:04:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-11 07:35:06 +0900

    YJIT: Remove dead code: `asm_comment!` checks `--yjit-dump-disasm`

commit ecebf1687dfd8defd44ff6514329224de4a598b1
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-09 05:30:57 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-09-09 05:30:57 +0900

    YJIT: Add more information to an assert message (#14481)

    YJIT: Add more information to an assert message in jit_guard_known_class (#14480)

    ---------

    Co-authored-by: Alan Wu <XrXr@users.noreply.github.com>

commit 600dc9cf1f8f52ba673bb43a718f7f980ea82404
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-09-09 05:11:34 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-09 05:29:50 +0900

    YJIT: Make the workflow names consistent with file names

commit 6d338434e335b1d4164a10cf12c7243119fd32c7
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-14 16:07:01 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Add missing write barrier for hash on iseq

    Found by wbcheck

commit 7de09550dad4f3921fba712009c1ec516a384fb2
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-13 07:06:38 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Add write barrier to rb_cArray_empty_frozen

    Found by wbcheck

commit f6448d65846d374d5096f53170cc9148f42df583
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-14 16:20:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Add write barrier to rb_cHash_empty_frozen

    Found by wbcheck

commit 4c0a2764b6634e6f2c11494fc015afd5c71537c2
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-10 02:09:10 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    More write barriers to local_iseq and parent_iseq

    Found by wbcheck

commit 3fb7c4f7e624de54fd18520585f3b294e83c2e20
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-08 12:10:05 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Use write barriers when loading catch table

    Found by wbcheck

commit eb2f79ff60065fd33a472f8e16d91b69b7a3735d
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-08 12:05:18 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Add missing write barriers to ibf_load

    Found by wbcheck

commit d2caeb1e70ea65a909bf2722706b2fd558982cc6
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-08 10:37:46 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Fix a missing write barrier to mandatory_only_iseq

    Found by wbcheck

commit ffbccd45ce04c050ae8c05162eb697bccc948a3b
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-09 02:52:33 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Add write barrier on tm_from_time->timew

    We want to always use time_set_timew, as timew is 64-bit even on 32-bit
    platforms so we need to be careful to both write that size, but still
    trigger write barriers if we end up with a heap object.

commit 34af4993bb57967d1ae3950472662667bce5d36c
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-09 02:59:13 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Add missing write barrier to time_init_copy

commit 6312c4000b1c2271141357b808e13e56c7bb3d6c
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-08 15:30:04 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Write barrier for zone on time

commit c2bda5c359fdf5bb9f1b813a066a3e47d445e620
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-10 10:13:38 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Add write barrier for hash in obj_traverse_i

    We are inserting directly into the st_table, so we need to issue a write
    barrier from the hash.

commit e1081f3b1aaf0766f4f01ce131b34b4b7ddbafa3
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-11 03:15:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Fix early write barrier rb_marshal_define_compat

    This write barrier occurred before the entry was added to the table, so
    if GC occurred when inserting into the table, the write could be missed.

commit ff124e9f93975e40ae91cff272a1c1d05273e615
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-15 17:18:22 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-09-06 01:05:06 +0900

    Fix too early writebarrier in tally_up

    After returning from the callback in st_update is the point that the
    hash table may be resized, which could trigger a GC and mark the table
    being used for the tally.

        RUBY_GC_LIBRARY=wbcheck WBCHECK_VERIFY_AFTER_WB=1 ./miniruby -e '(0...100).map(&:to_s).tally'

commit 38297e47945593daa3f395121c340260b9fae82d
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-08-16 21:38:03 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-28 09:34:34 +0900

    CI: windows: Skip rebuilding vcpkg packages when cache restored

commit 958bdafd8a2bd7f9247024753dbc540aa311094d
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-08-16 21:30:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-28 09:34:34 +0900

    CI: windows: Use possibly faster device for TMP/TEMP

commit ffc174470610eaa18e92254393f9b4a4c3ce54d8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-31 10:36:23 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-28 09:34:34 +0900

    Save vcpkg cache with master and stable branches

commit 0d367ce65fe4e85f207a8ca5f1f331dd90c6992e
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-08-27 22:26:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-28 07:19:58 +0900

    Fix bad NameError raised using sendforward instruction through vcall

    If you called a VCALL method and the method takes forwarding arguments
    and then you forward those arguments along using the sendforward
    instruction, the method_missing class was wrongly chosen as NameError
    instead of NoMethodError. This is because the VM looked at the CallInfo
    of the vcall and determined it needed to raise NameError. Now we detect
    that case and raise NoMethodError.

    [Backport #21535]

commit 5a42d267bfabc86f86cae2e83de24b1b86bc316a
  Author:     Janosch Müller <janosch84@gmail.com>
  AuthorDate: 2023-04-14 03:43:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-28 07:17:15 +0900

    Make word prop match join_control to conform to UTS 18

    See <https://bugs.ruby-lang.org/issues/19417#note-3>.

    https://unicode.org/reports/tr18/#word states word should match join_control chars.

    It did not previously:

    ```ruby
    [*0x0..0xD799, *0xE000..0x10FFFF].map { |n| n.chr 'utf-8' } => all_chars
    all_chars.grep(/\p{join_control}/) => jc
    jc.count # => 2
    jc.grep(/\p{word}/).count # => 0
    ```
    [Backport #19417]

    ---

    Backporting note: I regenerated `enc/unicode/15.0.0/name2ctype.h` using
    `make update-unicode`.

commit fd036dbc3f39e6bdce735edf9ca187a690fe2079
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-05-30 14:32:09 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-28 06:29:42 +0900

    Do not respect ruby2_keywords on method/proc with post arguments

    Previously, ruby2_keywords could be used on a method or proc with
    post arguments, but I don't think the behavior is desired:

    ```ruby
    def a(*c, **kw) [c, kw] end
    def b(*a, b) a(*a, b) end
    ruby2_keywords(:b)

    b({foo: 1}, bar: 1)
    ```

    This changes ruby2_keywords to emit a warning and not set the
    flag on a method/proc with post arguments.

    While here, fix the ruby2_keywords specs for warnings, since they
    weren't testing what they should be testing.  They all warned
    because the method didn't accept a rest argument, not because it
    accepted a keyword or keyword rest argument.

    [Backport #21402]

commit d49c7d0661faa964099b8c28ac316e33ae641051
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-08-17 17:13:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-28 06:13:52 +0900

    [Backport #21546] Make the generated pc file relocatable

commit b97a159dd9d9843673b4b1de2b056a0868e7e0f9
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-08-27 09:35:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-28 01:07:32 +0900

    Bump PRISM version number to avoid collision with RubyGems version

commit 1f421d092bb8c290df5cfc9e95a01e279ebadc42
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2025-07-18 07:20:20 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-28 01:07:32 +0900

    When reading from stdin, put a wrapper around the IO object

    The purpose of this commit is to fix Bug #21188.  We need to detect when
    stdin has run in to an EOF case.  Unfortunately we can't _call_ the eof
    function on IO because it will block.

    Here is a short script to demonstrate the issue:

    ```ruby
    x = STDIN.gets
    puts x
    puts x.eof?
    ```

    If you run the script, then type some characters (but _NOT_ a newline),
    then hit Ctrl-D twice, it will print the input string.  Unfortunately,
    calling `eof?` will try to read from STDIN again causing us to need a
    3rd Ctrl-D to exit the program.

    Before introducing the EOF callback to Prism, the input loop looked
    kind of like this:

    ```ruby
    loop do
      str = STDIN.gets
      process(str)

      if str.nil?
        p :DONE
      end
    end
    ```

    Which required 3 Ctrl-D to exit.  If we naively changed it to something
    like this:

    ```ruby
    loop do
      str = STDIN.gets
      process(str)

      if STDIN.eof?
        p :DONE
      end
    end
    ```

    It would still require 3 Ctrl-D because `eof?` would block.  In this
    patch, we're wrapping the IO object, checking the buffer for a newline
    and length, and then using that to simulate a non-blocking eof? method.

    This commit wraps STDIN and emulates a non-blocking `eof` function.

    [Backport #21188]

commit c6614d4cdcf36442c099c0d11a7cd24e530b35f1
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-08-12 03:31:52 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-12 04:21:19 +0900

    YJIT: Fix `mismatched_lifetime_syntaxes`, new in Rust 1.89.0

commit 5026609f47b79da093642d9a7731c3880d2a054e
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-06-10 03:26:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-06 07:42:27 +0900

    Fix missing write barrier through M_TBL

    When creating a new origin in ensure_origin, we need to fire a write
    barrier after RCLASS_SET_ORIGIN. rb_class_set_super allocates, so GC
    could happen there, either incrementally marking or promoting the newly
    allocated class, and only after RCLASS_SET_ORIGIN will origin mark
    object in the M_TBL.

commit 07f7832cffea879946a796e066ccb13ccb4b2abd
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-29 00:44:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-01 02:02:40 +0900

    Correct castings to use OnigDistance

commit e6e547f3e582d585bfa00f330d40473c74086c09
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 18:45:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-01 02:02:40 +0900

    Add castings to prevent warnings

commit 9e024046c5f3917149015b9458ec07b145c5428b
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 17:50:36 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-01 02:02:40 +0900

    Port a Oniguruma patch: Integer overflow in onig_search_gpos()

    https://github.com/kkos/oniguruma/commit/778a43dd56925ed58bbe26e3a7bb8202d72c3f3f

    It differs from the Oniguruma patch in that it dosen't use `onigenc_get_prev_char_head()`
    because this function's signature has been changed by Oniguruma and the change is not ported
    in Onigmo for now. This patch respects the current Onigmo implementation.

    Co-Authored-By: K.Kosako <kkos@users.noreply.github.com>

commit 142fc23975e9e240d6b4a5ee4d63c45ab969fd10
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 16:18:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-01 02:02:40 +0900

    Port a Oniguruma patch: Integer overflow in backward_search_range() and onig_search_gpos()

    https://github.com/kkos/oniguruma/commit/bfc36d3d8139b8be4d3df630d625c58687b0c7d4

    Co-Authored-By: K.Kosako <kkos@users.noreply.github.com>

commit 9f45db04ac36386aedfb35d1f3a5ff9603a24d68
  Author:     TSUYUSATO Kitsune <make.just.on@gmail.com>
  AuthorDate: 2025-07-28 16:05:41 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-08-01 02:02:40 +0900

    Port a Oniguruma patch: Integer overflow in forward_search_range()

    https://github.com/kkos/oniguruma/commit/db64ef3189f54917a5008a02bdb000adc514a90a

    Co-Authored-By: K.Kosako <kkos@users.noreply.github.com>

commit 8b505a286080fead52a603fcd2761c2d6b3e3aec
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-22 06:45:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-22 06:45:15 +0900

    merge revision(s) 148db9c80f11af1780f0f3685201f28de8f6b47a: [Backport #21259]

            Fix flipflop line numbers

            [ruby-core:121605]

commit d713896f19517ab688b13174e6346a87fd9e01ee
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-01-31 08:00:53 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-18 01:23:16 +0900

    YJIT: Explicitly specify C ABI to fix Rust warning

    Backport of 7e733ca55168e3b1f10b685f6e9a52cf1deb5aff to
    fix [Bug #21514].

commit 20cda200d3ce092571d0b5d342dadca69636cb0f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-16 01:27:14 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-16 01:27:14 +0900

    v3.4.5

commit 8b1c313d4029715ea0371142fde2ac7de0b2b22c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-06-03 15:57:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-16 01:23:42 +0900

    [ruby/etc] Alias value or join to take in old Ruby

    https://github.com/ruby/etc/commit/3dbe760bed

commit d2264185fad4f272a8cb5b9865fd3cd47e5e8291
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-16 01:23:42 +0900

    [ruby/json] [ruby/json] Run `have_func` with the header providing the declarations

    https://github.com/ruby/json/commit/95fb084027

    https://github.com/ruby/json/commit/9d080765cc

commit 8a9c6e0304f554b3d9d9c29bb07e1ab8544d5c37
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-16 01:23:42 +0900

    [ruby/strscan] Run `have_func` with the header providing the declarations

    https://github.com/ruby/strscan/commit/18c0a59b65

commit 2473d0b6f758f3826de70f66412a6eb678fb9002
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-06-12 10:32:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-16 01:23:42 +0900

    [ruby/strscan] Update extconf.rb
    (https://github.com/ruby/strscan/pull/158)

    - `have_func` includes "ruby.h" by default.
    - include "ruby/re.h" where `rb_reg_onig_match` is declared.

    https://github.com/ruby/strscan/commit/1ac96f47e9

commit 05a7d345ce0cc6fc5c55a4df0e633b145c3e6316
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-07-01 17:38:25 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-16 01:23:42 +0900

    [ruby/openssl] [ruby/openssl] Run `have_func` with the header providing the declarations

    https://github.com/ruby/openssl/commit/b6f56c4540

    https://github.com/ruby/openssl/commit/5277ca1431

commit 9a11bc5a2456448381235f25f0b51b33d2baf946
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-15 17:34:50 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-16 01:23:42 +0900

    Merge etc 1.4.6

commit 84d49322701ea1a2451440f53633ed9fd4a72f02
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-15 17:34:32 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-16 01:23:42 +0900

    Merge io-nonblock 0.3.2

commit 854787a8b23f82f59f15c3253a8461534495d7f5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-15 17:34:14 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-16 01:23:42 +0900

    Merge io-wait 0.3.2

commit 282cbf68f0d4dcb75aeeefea1fac4ffd9e7a319b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-15 17:33:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-16 01:23:42 +0900

    Merge io-console 0.8.1

commit cfdc2465d9fcd14eba512bfa80b5fd7c9e67f18e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-14 18:23:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-07-15 18:34:31 +0900

    Split restore and save actions from action/cache. We need to save always vcpkg cache

commit 596126ee5aa35a65bcaca60b92b5547ef1a9d2da
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 06:50:56 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:50:56 +0900

    merge revision(s) b42afa1dbcbb91e89852b3b3bc72484d7f0a5528, f1f0cc14cc7d3f9be35b203e5583f9224b1e2387, 543e3a1896ae2fe3b5b954f6497d261ab5663a15, ed2806117a0b76e4439ce1a061fae21d9e116d69, 46e4c8673747de96838d2c5dec37446d23d99d88: [Backport #21500]

            Suppress gcc 15 unterminated-string-initialization warnings

            Separate `__has_attribute` from `defined(__has_attribute)`

            Fix Visual C warnings:
            ```
            regenc.h(121): warning C4067: unexpected tokens following preprocessor directive - expected a newline
            ```

            Cast up `int` instruction code to `VALUE`

            Fix Visual C warnings:
            ```
            iseq.c(3793): warning C4312: 'type cast': conversion from 'int' to 'void *' of greater size
            iseq.c(3794): warning C4312: 'type cast': conversion from 'int' to 'void *' of greater size
            ```

            Do not let files depend on a phony target

            Detect `clock_gettime` and `clock_getres` for winpthreads

commit 782aef10bbdb63aba6d71e4f5f1876888c70efcb
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 06:48:27 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:48:27 +0900

    merge revision(s) d77e02bd85ab7f841df8d473bac214b9a92a3506: [Backport #21497]

            [Bug #21497] [ruby/socket]: add full prototype
            MIME-Version: 1.0
            Content-Type: text/plain; charset=UTF-8
            Content-Transfer-Encoding: 8bit

            otherwise, gcc 15 will complain:

            > init.c:573:19: error: too many arguments to function ‘Rconnect’; expected 0, have 3
            >   573 |     return (VALUE)Rconnect(arg->fd, arg->sockaddr, arg->len);
            >       |                   ^~~~~~~~ ~~~~~~~
            > In file included from init.c:11:
            > rubysocket.h:294:5: note: declared here
            >   294 | int Rconnect();
            >       |     ^~~~~~~~

            > sockssocket.c:33:9: error: too many arguments to function ‘SOCKSinit’; expected 0, have 1
            >    33 |         SOCKSinit("ruby");
            >       |         ^~~~~~~~~ ~~~~~~
            > In file included from sockssocket.c:11:
            > rubysocket.h:293:6: note: declared here
            >   293 | void SOCKSinit();
            >       |      ^~~~~~~~~

            Signed-off-by: Z. Liu <zhixu.liu@gmail.com>

commit 02744e58f3d410931a58873e1dab8752740e60ff
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 06:31:20 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:31:20 +0900

    merge revision(s) c1877d431e76f4a782d51602fa8487e98d302956: [Backport #21437]

            [ruby/date] [Bug #21437] Date#hash for large years

            Addresses https://bugs.ruby-lang.org/issues/21437

            Signed-off-by: Dmitry Dygalo <dmitry.dygalo@workato.com>

            https://github.com/ruby/date/commit/31f07bc576

commit 2af8f305542fd20537435046c1a558db5b2cacc5
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 06:30:53 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:30:53 +0900

    merge revision(s) 2e7e78cd590d20aa9d41422e96302f3edd73f623: [Backport #21440]

            [Bug #21440] Stop caching member list in frozen Data/Struct class

commit 508daebdcd730e34d5fb750880249deae8025b80
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 06:29:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:29:57 +0900

    merge revision(s) 1181a682a6c314c92686e3701defa1eb44068c4e, d84a811f31a65821642b165d712f380c0cc060e0: [Backport #21448]

            [Bug #21448] Use `getentropy(2)` only on macOS

            If this is not a system call, then it is using getrandom (which would
            have been tried already), and cannot be used as a replacement for the
            random devices.

            [Bug #21448] Reorder trials in `fill_random_bytes`

            First try dedicated system calls, such as `getrandom` or `getentropy`,
            next possible libraries, then fallback to `/dev/urandom`.

commit f0f97886fc0ef805835f0a0d7553e2a8abf988de
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 06:29:12 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:29:12 +0900

    merge revision(s) 1d94a9e1a4351e01f851dad250ba97dad859ee70: [Backport #21447]

            Fix handling of PM_CONSTANT_PATH_NODE node in keyword arguments with ARGS_SPLAT

            This was handled correctly in parse.y (NODE_COLON2), but not in
            prism. This wasn't caught earlier, because I only added tests for
            the optimized case and not the unoptimized case. Add tests for
            the unoptimized case.

            In code terms:

            ```ruby
            m(*a, kw: lvar::X)     # Does not require allocation for *a
            m(*a, kw: method()::X) # Requires allocation for *a
            ```

            This commit fixes the second case when prism is used.

commit fee92000fe96ac2dba0e87c5ed60c7440c8e2117
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 06:23:45 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:23:45 +0900

    merge revision(s) fa85d23ff4a02985ebfe0716b0ff768f5b4fe13d: [Backport #21380]

            [Bug #21380] Prohibit modification in String#split block

            Reported at https://hackerone.com/reports/3163876

commit 3a06b3d9f51bc4a3eef5fbaa035595ed34d65eba
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 06:16:02 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:17:12 +0900

    Revert "merge revision(s) ff222ac27afe712ef6ec2bb74c81cdde1a1fa176: [Backport #21370]"

    This reverts commit acb19e8707093593e967b6af03d92da5c570ffc6.

commit e68adac82a58e1b4a63d9e31047b59cbd515c54c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 06:14:34 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:14:34 +0900

    merge revision(s) 097d742a1ed53afb91e83aef01365d68b763357b: [Backport #20009]

            [Bug #20009] Support marshaling non-ASCII name class/module

commit 82e05dc945e3e2c5ab22be661f6caf6c7436461f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 06:10:16 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:10:16 +0900

    merge revision(s) f6cbf499bc98b851034fffb49fcbb59d495f6f7b: [Backport #21354]

            Fix Symbol#to_proc (rb_sym_to_proc) to be ractor safe

            In non-main ractors, don't use `sym_proc_cache`. It is not thread-safe
            to add to this array without a lock and also it leaks procs from one
            ractor to another. Instead, we create a new proc each time. If this
            results in poor performance we can come up with a solution later.

            Fixes [Bug #21354]

commit 585469aff3de855a9f3db8e51f12bf87300981af
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 06:04:20 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:04:20 +0900

    merge revision(s) 5ec9a392cdf7f971221dc073dd466bce877d8acb: [Backport #21439]

            [Bug #21439] Fix `PM_SPLAT_NODE` compilation error in for loops (#13597)

            [Bug #21439] Fix PM_SPLAT_NODE compilation error in for loops

            This commit fixes a crash that occurred when using splat nodes (*) as
            the index variable in for loops. The error "Unexpected node type for
            index in for node: PM_SPLAT_NODE" was thrown because the compiler
            didn't know how to handle splat nodes in this context.

            The fix allows code like `for *x in [[1,2], [3,4]]` to compile and
            execute correctly, where the splat collects each sub-array.

commit 79b73dd862f6e439142e56301e60a58ed1d44030
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 05:58:08 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 06:01:22 +0900

    merge revision(s) 8d49c05c134702c321198b70fbbf34dd80cc1ba6: [Backport #21395]

            Use the edge version of debug gem

commit 58d08abef567dab582ec5f7c3dcd2b8fabdaebd6
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 05:55:45 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 05:55:45 +0900

    merge revision(s) a084fef9afc7713aa4f4111f7e826c7ca1a607c7: [Backport #21099]

            [Bug #21099] Fix GC when Ractor list not initialized

            When the Ractor list is not initialized and a GC is ran at boot, then it
            would crash because the newobj_cache of the main Ractor is not cleared.
            This commit changes it to use ruby_single_main_ractor when it's available
            and iterate over the Ractor list when we have multiple Ractors.

commit c397c2d177a0b7fd13b69c5109418fbe1f9eccd1
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 05:55:05 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 05:55:05 +0900

    merge revision(s) 34b407a4a89e69dd04f692e2b29efa2816d4664a: [Backport #21394]

            Fix memory leak in Prism's RubyVM::InstructionSequence.new

            [Bug #21394]

            There are two ways to make RubyVM::InstructionSequence.new raise which
            would cause the options->scopes to leak memory:

            1. Passing in any (non T_FILE) object where the to_str raises.
            2. Passing in a T_FILE object where String#initialize_dup raises. This is
               because rb_io_path dups the string.

            Example 1:

                10.times do
                  100_000.times do
                    RubyVM::InstructionSequence.new(nil)
                  rescue TypeError
                  end

                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                13392
                17104
                20256
                23920
                27264
                30432
                33584
                36752
                40032
                43232

            After:

                9392
                11072
                11648
                11648
                11648
                11712
                11712
                11712
                11744
                11744

            Example 2:

                require "tempfile"

                MyError = Class.new(StandardError)
                String.prepend(Module.new do
                  def initialize_dup(_)
                    if $raise_on_dup
                      raise MyError
                    else
                      super
                    end
                  end
                end)

                Tempfile.create do |f|
                  10.times do
                    100_000.times do
                      $raise_on_dup = true
                      RubyVM::InstructionSequence.new(f)
                    rescue MyError
                    else
                      raise "MyError was not raised during RubyVM::InstructionSequence.new"
                    end

                    puts `ps -o rss= -p #{$$}`
                  ensure
                    $raise_on_dup = false
                  end
                end

            Before:

                14080
                18512
                22000
                25184
                28320
                31600
                34736
                37904
                41088
                44256

            After:

                12016
                12464
                12880
                12880
                12880
                12912
                12912
                12912
                12912
                12912

commit acb19e8707093593e967b6af03d92da5c570ffc6
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 05:54:31 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 05:54:31 +0900

    merge revision(s) ff222ac27afe712ef6ec2bb74c81cdde1a1fa176: [Backport #21370]

            compile.c: Handle anonymous variables in `outer_variable_cmp`

            [Bug #21370]

commit cdb039d3e4f76ee01744814e5f08395835fa8e63
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 05:53:56 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 05:53:56 +0900

    merge revision(s) 9f91f3617bab2ee220d298ddb874ef73b10dac23: [Backport #21383]

            Fix memory leak with invalid yield in prism

            [Bug #21383]

            The following script leaks memory:

                10.times do
                  20_000.times do
                    eval("class C; yield; end")
                  rescue SyntaxError
                  end

                  puts `ps -o rss= -p #{$$}`
                end

            Before:

                16464
                25536
                29424
                35904
                39552
                44576
                46736
                51600
                56096
                59824

            After:

                13488
                16160
                18240
                20528
                19760
                21808
                21680
                22272
                22064
                22336

commit 1bdae3404b2918a8823d2fbac2f9e30f778aa1c9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 05:52:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 05:52:11 +0900

    merge revision(s) 056497319658cbefe22351c6ec5c9fa6e4df72bd: [Backport #21357]

            [Bug #21357] Fix crash in Hash#merge with block

            Prior to https://github.com/ruby/ruby/commit/49b306ecb9e2e9e06e0b1590bacc5f4b38169c3c
            the `optional_arg` passed from `rb_hash_update_block_i` to `tbl_update`
            was a hash value (i.e. a VALUE). After that commit it changed to an
            `update_call_args`.

            If the block sets or changes the value, `tbl_update_modify` will set the
            `arg.value` back to an actual value and we won't crash. But in the case
            where the block returns the original value we end up calling
            `RB_OBJ_WRITTEN` with the `update_call_args` which is not expected and
            may crash.

            `arg.value` appears to only be used to pass to `RB_OBJ_WRITTEN` (others
            who need the `update_call_args` get it from `arg.arg`), so I don't think
            it needs to be set to anything upfront. And `tbl_update_modify` will set
            the `arg.value` in the cases we need the write barrier.

commit 247b452af3ace2000d27475a0cb05ebecf3bb29c
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-07-15 05:49:12 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-15 05:49:12 +0900

    merge revision(s) 49b306ecb9e2e9e06e0b1590bacc5f4b38169c3c: [Backport #21333]

            [Bug #21333] Prohibit hash modification inside Hash#update block

commit 1e3d24a0f47e142270bfb6073feb77f6364af052
  Author:     Takashi Kokubun <takashi.kokubun@shopify.com>
  AuthorDate: 2025-07-10 06:51:32 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-07-10 06:51:32 +0900

    [ruby/prism] Accept a newline after the defined? keyword [Backport #21197] (#13327)

    * [ruby/prism] Accept a newline after the defined? keyword

    [Bug #21197]

    https://github.com/ruby/prism/commit/22be955ce9

    * Fix a compilation error

    Co-authored-by: Stan Lo <stan001212@gmail.com>

    ---------

    Co-authored-by: Kevin Newton <kddnewton@gmail.com>
    Co-authored-by: Stan Lo <stan001212@gmail.com>

commit fd8a67fc8c10326042989da7d4e49b90c2f27ebb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-08 18:44:24 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-10 01:40:32 +0900

    Re-ordered vcpkg related steps. It may be affected with VsDevCmd.bat

commit 942d64b428ea72929d66198ff8751c4980b94777
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-08 18:42:02 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-07-10 01:40:32 +0900

    Use the latest version of Visual Studio with windows-2022 runner image

commit 5cd408a52ef6e31b16aeee548c900438dc560637
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-09 01:32:36 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-07-09 01:32:36 +0900

    Bump up resolv-0.6.2 for Ruby 3.4 (#13818)

commit 66437a400d9fa166f0d0c5770da80e41cde5815c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-07-02 01:31:57 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-07-02 01:31:57 +0900

    Backport GH-13617 for s390x (#13757)

commit 5df38256792b2823a3dc201c100d0bcccdc61688
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-06-25 14:37:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-06-25 15:22:45 +0900

    Specified --vcpkg-root with scoop directory

commit 0343fcdbfd848a8bc31be7f5c971944646ef4b45
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-06-25 13:40:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-06-25 15:22:45 +0900

    Replaced built-in binary cache of vcpkg to actions/cache

    ```
    %VCPKG_BINARY_SOURCES%: warning: The 'x-gha' binary caching backend has been removed. Consider using a NuGet-based binary caching provider instead, see extended documentation at https://learn.microsoft.com/vcpkg/users/binarycaching?WT.mc_id=vcpkg_inproduct_cli.
      on expression: clear;x-gha,readwrite
    ```

commit bb2c266498c4791b66071f426936fc49588a0922
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-06-25 13:38:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-06-25 15:22:45 +0900

    Added rake test to allow failures

commit 84a90636c5547f104ac382e996f44f0b2cab1050
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-26 20:11:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-06-25 15:22:45 +0900

    Win: Suppress false warnings from Visual C 17.14.1

    https://developercommunity.visualstudio.com/t/warning-C5287:-operands-are-different-e/10877942?

    It is not able to silence "operands are different enum types"
    warnings, even using an explicit cast, as the message says.

commit 8b59ba89a8c365ccf4a40ee6936ee855095eaf83
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-06-25 10:49:27 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-06-25 11:50:31 +0900

    Try to use windows-2025 runner for test-bundled-gems

commit d2ed304fd9546494ef865b5992e9b038a633bac5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-06-25 10:45:51 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-06-25 11:50:31 +0900

    Try to use the latest version of winsdk in windows-2025 runner

commit 309b1aaf1f92185eb060f6520a10498b90de856e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-26 20:37:14 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-06-25 11:50:31 +0900

    [Bug #21255] Win32: Do not export `__declspec(selectany)` symbols

    ```
    x64-vcruntime140-ruby350.def : error LNK2001: unresolved external symbol Avx2WmemEnabledWeakValue
    ```

commit 3c8be029b6d58e0edbe5d32678b1b8565886a011
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-06-25 10:02:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-06-25 11:50:31 +0900

    Try to use the latest version of Visual Studio in windows-2025 runner.

commit edfcbacabae6317195a55f2b83fafe2d2b3f6fc8
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2025-06-18 05:56:26 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-06-21 02:13:59 +0900

    thread_cleanup: set CFP to NULL before clearing ec's stack

    We clear the CFP first so that if a sampling profiler interrupts the current thread during `rb_ec_set_vm_stack`,
    `thread_profile_frames` returns early instead of trying to walk the stack that's no longer set on the ec.

    The early return in `thread_profile_frames` was introduced at eab7f4623fb.

    Fixes [Bug #21441]

commit c57efbfb3ac3848f954735600bbab1ea814dd742
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2025-05-03 21:39:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-06-19 03:09:20 +0900

    Fix `heap-use-after-free` in `free_fast_fallback_getaddrinfo_entry` (#13231)

    This change addresses the following ASAN error:

    ```
    ==36597==ERROR: AddressSanitizer: heap-use-after-free on address 0x512000396ba8 at pc 0x7fcad5cbad9f bp 0x7fff19739af0 sp 0x7fff19739ae8
      WRITE of size 8 at 0x512000396ba8 thread T0
      [643/756] 36600=optparse/test_summary
          #0 0x7fcad5cbad9e in free_fast_fallback_getaddrinfo_entry /home/runner/work/ruby-dev-builder/ruby-dev-builder/ext/socket/raddrinfo.c:3046:22
          #1 0x7fcad5c9fb48 in fast_fallback_inetsock_cleanup /home/runner/work/ruby-dev-builder/ruby-dev-builder/ext/socket/ipsocket.c:1179:17
          #2 0x7fcadf3b611a in rb_ensure /home/runner/work/ruby-dev-builder/ruby-dev-builder/eval.c:1081:5
          #3 0x7fcad5c9b44b in rsock_init_inetsock /home/runner/work/ruby-dev-builder/ruby-dev-builder/ext/socket/ipsocket.c:1289:20
          #4 0x7fcad5ca22b8 in tcp_init /home/runner/work/ruby-dev-builder/ruby-dev-builder/ext/socket/tcpsocket.c:76:12
          #5 0x7fcadf83ba70 in vm_call0_cfunc_with_frame /home/runner/work/ruby-dev-builder/ruby-dev-builder/./vm_eval.c:164:15
    ...
    ```

    A `struct fast_fallback_getaddrinfo_shared` is shared between the main thread and two child threads.
    This struct contains an array of `fast_fallback_getaddrinfo_entry`.

    `fast_fallback_getaddrinfo_entry` and `fast_fallback_getaddrinfo_shared` were freed separately, and if `fast_fallback_getaddrinfo_shared` was freed first and then an attempt was made to free a `fast_fallback_getaddrinfo_entry`, a `heap-use-after-free` could occur.

    This change avoids that possibility by separating the deallocation of the addrinfo memory held by `fast_fallback_getaddrinfo_entry` from the access and lifecycle of the `fast_fallback_getaddrinfo_entry` itself.

commit 584365af7baeb80b74d31a26b8ec51e66b2ccc1a
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2025-01-29 22:19:04 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-06-19 03:09:20 +0900

    Ensure that memory is not freed before calling `free_fast_fallback_getaddrinfo_*` (#12661)

    Ensure that `getaddrinfo_entry` and `getaddrinfo_shared` exist before free them in the main thread.

commit 45ddafb95bd732f7305925a779cd8403ac30e1bf
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-06-19 02:47:59 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-06-19 02:47:59 +0900

    Fix use-after-free when resizing exivars (#13637)

    Fix generic_ivar_set_shape_ivptr for table rebuild

    [Bug #21438]

    Previously GC could trigger a table rebuild of the generic ivar
    st_table in the middle of calling the st_update callback. This could
    cause entries to be reallocated or rearranged and the update to be for
    the wrong entry.

    This commit adds an assertion to make that case easier to detect, and
    replaces the st_update with a separate st_lookup and st_insert.

    Also free after insert in generic_ivar_set_shape_ivptr

    Previously we were performing a realloc and then inserting the new value
    into the table. If the table was flagged as requiring a rebuild, this
    could trigger GC work and marking within that GC could access the ivptr
    freed by realloc.

    Co-authored-by: John Hawthorn <john@hawthorn.email>
    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

commit 2cce628721728409a26c2d4732f63419785c7fd8
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-05-31 06:00:27 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-05-31 06:00:27 +0900

    Sync lockfile from rubygems/rubygems (#13472)

    * Sync lockfile from rubygems/rubygems

    * Restore lockfile for test-bundler

    In the past, bundler updated platform without normalized variable like arm64-darwin-23.
    We ignored that update. But the current bundler uses arm64-darwin for that.

    ---------

    Co-authored-by: Hiroshi SHIBATA <hsbt@ruby-lang.org>

commit 3941954fd48265f5eeeb4d339ffe48699fbbe1ec
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-05-28 21:09:55 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-29 03:14:49 +0900

    Remove unnecessary `GEM_PATH` modification

commit baa5f15b336c92c8ee8498056bd5d0e8d5b80f57
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-04-08 23:24:01 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-29 03:14:49 +0900

    Sync Bundler and adapt to new spec setup

commit 89bcc631f491bae1893bb578fb79dae3fc80dfe4
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-05-27 19:25:09 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-29 03:14:49 +0900

    Revert "Revert https://github.com/rubygems/rubygems/commit/d74fa0fdda481043112f9de179be572b74a711ed"

    This reverts commit 7dcfdf1d7d1b1d13ab9bdc6f2b4bb89c78629332.

commit 877ae93e83d67eb78460af98384d96e7361fbd99
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-05-28 21:18:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-29 03:14:49 +0900

    Initialize `gems` tmp when initializing bundled_gems_spec suite

    That way it works even if no Bundler specs have run before.

commit 439428c8c5eb694a1262fee1e7c13766f065e992
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-22 12:42:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-23 12:56:37 +0900

    Skip failing example on Ubuntu runner of ruby/ruby

    https://github.com/ruby/ruby/actions/runs/14585602800/job/40910453142

commit 2de5cb2f13b7afaa6e2f4914eb934211255b4d37
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-23 09:37:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-23 12:56:37 +0900

    Skip RBS tests for RDocPluginParserTest caused by interface change of RDoc 6.14.0

    https://github.com/ruby/ruby/actions/runs/15199473008/job/42750815986?pr=13421

    ```
     Error: ArgumentError: wrong number of arguments (given 0, expected 1)
      /Users/runner/work/ruby/ruby/src/lib/rdoc/store.rb:123:in 'initialize'
      /Users/runner/work/ruby/ruby/src/gems/src/rbs/test/rbs/rdoc/rbs_parser_test.rb:8:in 'Class#new'
      /Users/runner/work/ruby/ruby/src/gems/src/rbs/test/rbs/rdoc/rbs_parser_test.rb:8:in 'RDocPluginParserTest#parser'
      /Users/runner/work/ruby/ruby/src/gems/src/rbs/test/rbs/rdoc/rbs_parser_test.rb:147:in 'RDocPluginParserTest#test_instance_method_comment_and_tokens'
    ```

commit df487932fad588f57b6fc77e032beaef9751eb98
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-23 09:24:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-23 12:56:37 +0900

    test/lib/helper.rb is only for ruby/rdoc repo

commit 7dcfdf1d7d1b1d13ab9bdc6f2b4bb89c78629332
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-23 08:36:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-23 12:56:37 +0900

    Revert https://github.com/rubygems/rubygems/commit/d74fa0fdda481043112f9de179be572b74a711ed

commit bc2e95ee93d3e0584e4d916bed8bb0382762c4ec
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2025-05-23 06:50:09 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-23 07:04:47 +0900

    Apply new RDoc config options

commit 03eb777c69d64aa4941891a784c1fd67b44ea42c
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2025-05-23 06:49:04 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-23 07:04:47 +0900

    Sync RDoc 6.14.0

commit ca1ea9578485c27daac1e16107cb48551a58d8ad
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-05-21 00:58:32 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-23 01:21:10 +0900

    Include stdbool.h without checking with autoconf

    As reported in <https://bugs.ruby-lang.org/issues/21340>, older autoconf
    have an AC_HEADER_STDBOOL that's incompatible with C23. Autoconf 2.72
    fixed the macro, but also mentions that it's obsolescent since all
    current compilers have this header.

    Since we require C99 [1] and VS 2015 [2], should be able take
    that suggestion and include stdbool.h without a check. This worked
    fine on rubyci.org.

    [Backport #21340]

    [1]: https://bugs.ruby-lang.org/issues/15347
    [2]: https://bugs.ruby-lang.org/issues/19982

commit 616771e34e651d2a09ab3dad77d826c2100512e8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-22 16:15:55 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-23 01:20:28 +0900

    Merge RubyGems-3.6.9 and Bundler-2.6.9

commit d766eceb48792e938ed4a2e303df7027e3c43c1e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-22 16:14:56 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-23 01:20:28 +0900

    Merge RubyGems-3.6.8 and Bundler-2.6.8

commit 8125827578ed5ce3487f9ee08a4adc072f74a234
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-21 18:20:33 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-23 01:19:24 +0900

    windows-2025 runner removed D drive from their environment

commit c104fc41b0e8ce80f4178c3b384d1405570714b2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-21 17:33:24 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-23 01:19:24 +0900

    Disabled TRAP cache of CodeQL

commit a38531fd3f617bf734ef7d6c595325f69985ea1d
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-05-14 09:59:23 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-14 12:11:06 +0900

    v3.4.4

commit d8e7ab99a30f60620cccdff9e2e729968a4d84d1
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-05-14 12:10:15 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2025-05-14 12:10:15 +0900

    YJIT: Split the block on optimized getlocal/setlocal (#13331)

commit a21b88a6081edaa73549caa285d4f0d26d1f8462
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-14 10:37:59 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-14 12:01:10 +0900

    [Bug #21331] Prohibit hash modification during stlike loop

commit 22f2047a3d8b02018269b49dbcd23b8101314009
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-14 10:26:04 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-14 12:00:58 +0900

    Remove unused retval assignments

commit fbcb3271857115596d9a2760bb117d196d7f57a9
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-05-14 10:23:16 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-14 12:00:53 +0900

    Revert "[Bug #21331] Prohibit modification during stlike loop"

    This reverts commit bb180b87b43c45e17ff49735a26d7a188d5c8396, which
    caused "malloc during GC" error on wasm.

commit 65e02ab1a6e4482f417ec1d1cb4453958ad36ca3
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-05-14 09:18:43 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-14 09:18:43 +0900

    merge revision(s) 3e47e7a499acd256be549935fcb559d3c82e556c, b48b841378f80e16378ceb83f3b78e52df9ae023, 2fe8b9cd3d308d754f3d33a948dfb1dd782a10dc: [Backport #21327]

            Fix redefinition of `clock_gettime` and `clock_getres`

            winpthreads-git 12.0.0.r720 provides `clock_gettime` and
            `clock_getres` as inline functions.

            digest.so needs ruby/digest.h which is installed by build-ext

            Copy to path with the base name

commit 862480a316c014d2b4659b22cd12e311c0810105
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-05-14 09:14:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-14 09:14:49 +0900

    merge revision(s) bb180b87b43c45e17ff49735a26d7a188d5c8396: [Backport #21331]

            [Bug #21331] Prohibit modification during stlike loop

commit 7e44df91b6d01be68391a029997f5ccdabe80603
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-04-29 21:13:17 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-08 02:04:46 +0900

    Fix C23 (GCC 15) WIN32 compatibility for rb_define_* functions

    Backport [Bug #21286]

commit 4aac15063094d30c3ed0c3639ffbf54a595731a5
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-05-07 07:35:58 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-07 07:35:58 +0900

    Skip an unstable Ractor test

commit 7afa08ce8d245c7d756ddaeb78daddb61fd0e271
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-05-06 05:35:28 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-07 07:34:58 +0900

    YJIT: End the block after OPTIMIZE_METHOD_TYPE_CALL

commit ac311437d3c4d60fe4ac100e9652b0cbc3e5f481
  Author:     Daniel Colson <danieljamescolson@gmail.com>
  AuthorDate: 2025-04-29 01:54:25 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-03 01:02:57 +0900

    [Backport 3.4] Fix C level backtraces for USE_ELF

    [Backport #21289]

commit 3557739db95833454de34a4169212633dec8c76d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-16 10:59:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:56 +0900

    [rubygems/rubygems] Fixed rubocop issue: Layout/SpaceInsideBlockBraces

    https://github.com/rubygems/rubygems/commit/77a52b011a

commit 1a0a1690cdcda415879e28302d888a1dc1e3d74a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-04-16 08:29:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:56 +0900

    Run the proper version of `rake`

commit 9e22d6fb1e546b4dde2a518cfc808e5d89044cff
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 13:31:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:56 +0900

    Use windows-2022 image for test-bundled-gems

    rake test is broken with system ruby

    https://github.com/ruby/ruby/actions/runs/14768933827/job/41465573970?pr=13221

commit b04f3995ea520d723de5507203abc63537ad8fd3
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 12:12:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:56 +0900

    Bump up the latest version of actions

commit 6e95400497b8cc6663fb417a53bf2d33b265bfb1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 11:34:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:56 +0900

    ubuntu-20.04 is retired

commit 321fb434ff74bac551eb0fa548bb55ccd895e2ba
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 11:22:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:56 +0900

    Rename matrix.vs to matrix.os. It's not Visual Studio version now

commit c11836eceace1339d8b4388ed9625acac837241d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-05-01 11:16:54 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-05-01 16:10:56 +0900

    Use windows-2022 and windows-2025 because windows-2019 is EOL at June 2025

commit 53549b3b1ff412daed3e8063329b4538373796cb
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-01-17 11:53:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-01 03:29:58 +0900

    Supply LIBCLANG_PATH for clang-14 for yjit-bindgen

    Or else it gets confused from all the different versions of LLVM in the
    image.

commit 84e7f671606ed504b37f5c6979184973955969b6
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-01-17 04:04:52 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-01 02:58:47 +0900

    Use clang-14 to match the libclang version bindgen finds by default

commit 4fc785b91bec95cf4bb7a604fcb302db4deece90
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-01-16 16:08:31 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-01 02:38:18 +0900

    sd ubuntu-20.04 ubuntu-22.04 .github/workflows/*

commit aed8b7ff54a8cd94ea9929d1df9bcfde07331af0
  Author:     nick evans <nick@rubinick.dev>
  AuthorDate: 2025-05-01 01:56:12 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-05-01 02:37:13 +0900

    Bump net-imap to v0.5.8 for Ruby 3.4 (CVE-2025-43857)

    v0.5.7 addresses CVE-2025-43857 (GHSA-j3g3-5qv5-52mj).

    v0.5.8 fixes some bugs in `Net::IMAP::SequenceSet`.

commit 50b1759be00713535c41f5650feb3967c533450a
  Author:     Rian McGuire <rian@rian.id.au>
  AuthorDate: 2025-04-28 21:50:29 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-29 01:23:33 +0900

    YJIT: Fix potential infinite loop when OOM (GH-13186)

    Avoid generating an infinite loop in the case where:
    1. Block `first` is adjacent to block `second`, and the branch from `first` to
       `second` is a fallthrough, and
    2. Block `second` immediately exits to the interpreter, and
    3. Block `second` is invalidated and YJIT is OOM

    While pondering how to fix this, I think I've stumbled on another related edge case:
    1. Block `incoming_one` and `incoming_two` both branch to block `second`. Block
       `incoming_one` has a fallthrough
    2. Block `second` immediately exits to the interpreter (so it starts with its exit)
    3. When Block `second` is invalidated, the incoming fallthrough branch from
       `incoming_one` might be rewritten first, which overwrites the start of block
       `second` with a jump to a new branch stub.
    4. YJIT runs of out memory
    5. The incoming branch from `incoming_two` is then rewritten, but because we're
       OOM we can't generate a new stub, so we use `second`'s exit as the branch
       target. However `second`'s exit was already overwritten with a jump to the
       branch stub for `incoming_one`, so `incoming_two` will end up jumping to
       `incoming_one`'s branch stub.

    Backport [Bug #21257]

commit d0b7e5b6a04bde21ca483d20a1546b28b401c2d4
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-04-14 16:33:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-14 16:33:49 +0900

    v3.4.3

commit 1c23c3095325a4ade2064cc3b35ce8e678e03ebf
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-04-14 16:29:03 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-14 16:29:03 +0900

    Revert "merge revision(s) 052794bfe1970e90f4f4f9e37fc362dd27903a8d: [Backport #21197]"

    This reverts commit e630a0f7ae909dafe2e1dbc47baf90cd795b4a5f.

commit 1b6f9cd6ea5715ad33d8ba4c78382aa8aafdbcd4
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-04-14 16:25:55 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-14 16:25:55 +0900

    merge revision(s) 0d6263bd416338a339651fb97fe4d62701704c4b: [Backport #21220]

            Fix coverage measurement for negative line numbers

            Fixes [Bug #21220]

            Co-Authored-By: Mike Bourgeous <mike@mikebourgeous.com>
            Co-Authored-By: Jean Boussier <jean.boussier@gmail.com>

commit 9abd48df705c37f69ec9fd954f84cbbbd65db624
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-04-14 16:21:51 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-14 16:21:51 +0900

    merge revision(s) 3a7b9ca93b91dcc086b9ac8b9957e59268f9493b: [Backport #21217]

            Fix `Integer.sqrt` to never exceed actual value

            `Integer.sqrt` uses `sqrt(3)` from libm for small values.
            This method must return a value less than or equal to the actual integer
            square root, but libm's sqrt does not always guarantee that.

            This change corrects that by decrementing the result if necessary.

            Fixes [Bug #21217]

commit 7b5e4125b9935cd78d80719de018dad446780e40
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-04-14 16:20:04 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-14 16:20:04 +0900

    merge revision(s) f27ed98effff9891d28edc7119d45811bcedd510: [Backport #21183]

            [ruby/prism] Freeze `Prism::VERSION`

            Closes https://github.com/ruby/prism/pull/3422

            https://github.com/ruby/prism/commit/b488a84253

commit e630a0f7ae909dafe2e1dbc47baf90cd795b4a5f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-04-14 16:18:37 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-14 16:18:37 +0900

    merge revision(s) 052794bfe1970e90f4f4f9e37fc362dd27903a8d: [Backport #21197]

            [ruby/prism] Accept a newline after the defined? keyword

            [Bug #21197]

            https://github.com/ruby/prism/commit/22be955ce9

commit 86e37a9b707057922198137aab99bff5cc760317
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-15 00:36:04 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-10 08:02:37 +0900

    Test for the crash

commit 7e093fb43a692935823de1bb32ac4f05e46329bb
  Author:     Luke Jahnke <luke.jahnke@gmail.com>
  AuthorDate: 2025-03-14 22:38:33 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-10 08:02:37 +0900

    Fix crash in TCPSocket.open

    Fix segfault crash observable with TCPSocket.open(nil, nil)

commit e580145171c16d3ca31ee0732e3ed87ff7dfd774
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-09 09:19:31 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-09 09:54:29 +0900

    Merge RubyGems-3.6.7 and Bundler-2.6.7

commit db2bf9f078c21b9e0234a736214ed74642d9f795
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-09 09:19:10 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-09 09:54:29 +0900

    Merge RubyGems-3.6.6 and Bundler-2.6.6

commit bbf5f12331913f16b8f635626d4a438bd3ffd599
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 19:30:24 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-04 07:32:20 +0900

    Use EnvUtil.apply_timeout_scale

commit 4d6143dd18e295849d05a9e75891dc52a72a782f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 19:07:08 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-04 07:32:20 +0900

    Extend open_timeout for test failure on s390x

    https://rubyci.s3.amazonaws.com/s390x/ruby-master/log/20250403T060004Z.fail.html.gz

commit 34e990fcec828a3e555ed353780e4e94e50b70a6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 11:54:19 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-03 13:45:14 +0900

    Picking test fix from https://github.com/ruby/ruby/commit/3d8a66568e8106b367665d716e0d3c8c8208aa07

    The original change is https://github.com/ruby/ruby/commit/d78ff6a767ca813ac5fa178dd7611f20a993c191

commit aa5d760fba6044594b642daee00544d59037cc83
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-03 09:40:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-03 13:13:54 +0900

    Enforce to use CMake 3 because CMake 4 is not compatible to build libyaml via vcpkg

commit e3fc29a9b7fd7869723d2e13185c1387c6d026db
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-04-02 19:08:39 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-04-03 01:16:27 +0900

    Improve backtrace of errors raised by `Socket.tcp_with_fast_fallback`

    [Bug #21211]

    Socket errors raised from background threads are hard to track down because
    their backtrace starts from the spawned thread.

    To solve this we can raise a new error with the old one as `cause`.

commit 66d133ab19726899c23db77e808674aa031a062d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-04-01 15:20:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-04-02 10:33:47 +0900

    [rubygems/rubygems] Bump up minimum required version for cmake 4

    https://github.com/rubygems/rubygems/commit/3e77caeddf

commit 5ab0b9143ab5a92b134c6788f893ac539825b300
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-24 15:43:40 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-28 08:41:51 +0900

    [Backport #21141] [DOC] Refine description of `Time#utc?`

commit bd99a2ef6ac72a43aacf8543aef19e8c1bcb354f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-15 16:15:04 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-28 08:41:51 +0900

    [Backport #21141] [DOC] Clarify what time is in UTC

commit 00c6e537ce46e4482c77fa8676a4a1e44cc6f623
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2025-03-22 01:19:42 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-28 07:23:56 +0900

    FCALL shouldn't be forwarded from caller

    When we forward an FCALL (a method call with an implicit self), we
    shouldn't forward the FCALL flag because it ignores method visibility
    checks.  This patch removes the FCALL flag from callers.

    [Bug #21196]

commit aa7380f9d8a9a37d7c4d8f827d8b119c0ffbb6f2
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2025-03-23 09:42:04 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-28 07:23:31 +0900

    Fix handling of `error`/`errno` in `io_internal_wait`. (#12961)

    [Bug #21195]

commit 2efa40053917eca8f1f9ee434cef188a4486f78f
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2025-03-21 02:19:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-03-24 13:24:30 +0900

    [rubygems/rubygems] Support git 2.49

    One error message that we parse is now slightly different.

    https://github.com/rubygems/rubygems/commit/758528791d

commit 5b3970f68b9108e0976b75b5d67da8c56eaa9db4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-01-29 16:55:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-21 01:41:35 +0900

    [Bug #21094] Update nested module names when setting temporary name

    [Backport #21094]

commit 8b491169c32621d4e74324eed08465448dfc54d5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-17 21:37:00 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-21 01:38:42 +0900

    [Bug #21186] multibyte char literal should be a single letter word

    [Backport #21186]

commit 6ca43e9b16ded4f884e9a54e9f8f6f6c4e5f0f73
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-03-11 11:37:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-15 04:04:25 +0900

    Push a real iseq in rb_vm_push_frame_fname()

    Previously, vm_make_env_each() (used during proc
    creation and for the debug inspector C API) picked up the
    non-GC-allocated iseq that rb_vm_push_frame_fname() creates,
    which led to a SEGV when the GC tried to mark the non GC object.

    Put a real iseq imemo instead. Speed should be about the same since
    the old code also did a imemo allocation and a malloc allocation.

    Real iseq allows ironing out the special-casing of dummy frames in
    rb_execution_context_mark() and rb_execution_context_update(). A check
    is added to RubyVM::ISeq#eval, though, to stop attempts to run dummy
    iseqs.

    [Bug #21180]

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

commit 31502b0d8569b806d723a0e49a919921bf5d6e2c
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-03-12 02:14:13 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-15 04:04:25 +0900

    Have `ast` live longer in ISeq.compile_file to fix GC stress crash

    Previously, live range of `ast_value` ended on the call right before
    rb_ast_dispose(), which led to premature collection and use-after-free.

    We observed this crashing on -O3, -DVM_CHECK_MODE, with GCC 11.4.0 on
    Ubuntu.

    Co-authored-by: Aaron Patterson <tenderlove@ruby-lang.org>

commit 5cc439829783e83d4189e1dbaf11a239e8db8471
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-02-26 11:13:41 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-14 01:28:17 +0900

    Check LoadError first

    The message from dlerror is not our concern.

commit adc7f046ec931ea8f5e3868ecdbd1556bffebce2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-26 09:09:56 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-14 01:28:17 +0900

    Added assertion strings with Xcode 16.3 beta

commit ae2fcdc0f705e767045c2bd5253e8eae733d2edb
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2023-08-20 13:04:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-13 02:51:50 +0900

    [Bug #19841] Refine error on marshaling recursive USERDEF

commit 0e416faf450159a989fba87b41f3e3874a4af129
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-11 05:18:59 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-12 01:16:22 +0900

    Fix `Socket.tcp_with_fast_fallback` to be usable from a Ractor

    [Bug #21179]

    ```
    socket.rb:1046:in 'Socket::HostnameResolutionStore#get_addrinfo': can not access non-shareable objects in constant
    Socket::HostnameResolutionStore::PRIORITY_ON_V6 by non-main ractor. (Ractor::IsolationError)
            from socket.rb:724:in 'block in Socket.tcp_with_fast_fallback'
            from socket.rb:720:in 'Socket.tcp_with_fast_fallback'
    ```

commit 762e76cc50db059e71d1f6c13674103a488f5171
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-03-06 04:22:01 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-11 04:57:06 +0900

    RUBY_FREE_AT_EXIT does not work when error in -r

    [Bug #21173]

    When loading a file using the command line -r, it is processed before
    RUBY_FREE_AT_EXIT is checked. So if the loaded file raises an error, it
    will cause memory to not be freed with RUBY_FREE_AT_EXIT.

    For example `ruby -rtest.rb -e ""` will report a large amount of memory
    leaks if `test.rb` raises.

commit e15a9044d7a9ee5435e7a6d19ef9ac46b50bb880
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-03-04 10:22:17 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-11 04:04:54 +0900

    [Bug #21163] Fix hexadecimal float conversion

commit 161cffb39970b147f92d779834a393b5637d6d00
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-03-06 01:29:32 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-07 02:24:37 +0900

    Fix a race condition with interned strings sweeping.

    [Bug #21172]

    This fixes a rare CI failure.

    The timeline of the race condition is:

    - A `"foo" oid=1` string is interned.
    - `"foo" oid=1` is no longer referenced and will be swept in the future.
    - Another `"foo" oid=2` string is interned.
    - `register_fstring` finds `"foo" oid=1`, but since it is about to be swept,
      removes it from `fstring_table` and insert `"foo" oid=2` instead.
    - `"foo" oid=1` is swept, since it has the `RSTRING_FSTR` flag,
      a `st_delete` is issued in `fstring_table` which removes `"foo" oid=2`.

    I don't know how to reproduce this bug consistently in a single test
    case.

commit 698741d73a0e6c998fb47297ce7b129366b4835b
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-03-05 05:54:33 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-06 08:15:45 +0900

    Replace tombstone when converting AR to ST hash

    [Bug #21170]

    st_table reserves -1 as a special hash value to indicate that an entry
    has been deleted. So that that's a valid value to be returned from the
    hash function, do_hash replaces -1 with 0 so that it is not mistaken for
    the sentinel.

    Previously, when upgrading an AR table to an ST table,
    rb_st_add_direct_with_hash was used which did not perform the same
    conversion, this could lead to a hash in a broken state where one if its
    entries which was supposed to exist being marked as a tombstone.

    The hash could then become further corrupted when the ST table required
    resizing as the falsely tombstoned entry would be skipped but it would
    be counted in num entries, leading to an uninitialized entry at index
    15.

    In most cases this will be really rare, unless using a very poorly
    implemented custom hash function.

    This also adds two debug assertions, one that st_add_direct_with_hash
    does not receive the reserved hash value, and a second in
    rebuild_table_with, which ensures that after we rebuild/compact a table
    it contains the expected number of elements.

    Co-authored-by: Alan Wu <alanwu@ruby-lang.org>

commit 9a7e3aab487286ba0dfeb17089d41424fa3a515b
  Author:     a5-stable <sh07e1916@gmail.com>
  AuthorDate: 2025-03-05 22:46:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-06 01:38:24 +0900

    yjit.rb: Fix parameter name in documentation

commit d40c6cf7b606edb815adf7a8e9abe98f38a8f747
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-02-17 21:46:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-05 06:04:27 +0900

    [Bug #21144] Win32: Use Windows time zone ID if TZ is not set

    If the TZ environment variable is not set, the time zone names
    retrieved from the system are localized for UI display and may vary
    across editions and language packs for the same time zone.
    Use the time zone IDs that are invariant across environments instead.

commit 3d744a0a9436fbf7901c345055dd3d775b518361
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-02-28 05:53:38 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-04 08:42:16 +0900

    [ruby/prism] Use a locale-insensitive version of tolower

    [Bug #21161]

    The `tolower` function provided by the libc is locale dependent
    and can behave in ways you wouldn't expect for some value
    of `LC_CTYPE`.

    https://github.com/ruby/prism/commit/e3488256b4

    Co-Authored-By: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit ddb73fbd115631e6dec3bdd230c1cfc13027602e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-02-27 11:07:36 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-04 08:41:33 +0900

    [Bug #21159] module names should not be modifiable

commit 82e43a9cde3a876dc492d635e53f77ba2b19408f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-01-29 16:55:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-04 08:41:33 +0900

    [Feature #19521] Test for `Module#set_temporary_name`

commit eb8ee7c189d051e656f781ce2775ede1157edd6a
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2025-02-18 10:23:14 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-04 07:01:09 +0900

    Ensure IO.copy_stream buffer is an independent string

    Otherwise, changes to the buffer by the destination write method
    could result in data changing for supposedly independent strings.

    Fixes [Bug #21131]

commit 6d2c7d4304bbf8450d31b624f5dc40a92e44f00b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-01-13 02:07:05 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-03-04 06:45:41 +0900

    [Bug #21030] Fix step for non-numeric range

    When the end points of an inclusive range equal, `Range#step` should
    yields the element once.

commit 7759263c5154d3c561a8488ba196205a1526bf61
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-28 14:47:54 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2025-02-28 16:43:27 +0900

    Visual Studio 2022 17.13.x couldn't build miniruby.exe. It prevents other PRs.

    https://github.com/actions/runner-images/commit/e43209e1398efe7739e42509162b3187515b9359

    ```
    user32.lib advapi32.lib shell32.lib ws2_32.lib iphlpapi.lib gmp.lib imagehlp.lib shlwapi.lib bcrypt.lib
    linking miniruby.exe
       Creating library miniruby.lib and object miniruby.exp
    [BUG] heap_idx_for_size: allocation size too large (size=145u, heap_idx=25u)
    ruby 3.5.0dev (2025-02-28T01:12:37Z pull/12827/merge 3d6a5a1883) [x64-mswin64_140]
    ```

    ```
    user32.lib advapi32.lib shell32.lib ws2_32.lib iphlpapi.lib imagehlp.lib shlwapi.lib bcrypt.lib
      linking miniruby.exe
      NMAKE : fatal error U1077: '@ miniruby.exe -v' : return code '0xc0000005'
    ```

commit 5f2e0cb0c65e56b0f8008de74a563d9a084d30a2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-26 18:16:48 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-28 02:00:25 +0900

    Merge uri-1.0.3

commit 5653eb90bb1b548f0bbe92af717da44a77eb0d55
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-26 18:15:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-28 02:00:25 +0900

    Merge cgi-0.4.2

commit 8d2be590ad567b7b03286731f9a9754d24370f00
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-02-24 23:20:12 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-26 02:05:34 +0900

    [Bug #21153] Add missing op-assign to top const in `command_asgn`

    It was defined in `arg` only; add that pattern to `command_asgn` as
    well.

commit 06451f0dec107625f3a7794230e90d539a55a08a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-21 09:28:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-21 09:50:20 +0900

    Merge RubyGems-3.6.5 and Bundler-2.6.5

commit a0025b6e5d440139ebc16a555cddb4dc9dd45449
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-21 09:27:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-21 09:50:20 +0900

    Merge RubyGems-3.6.4 and Bundler-2.6.4

commit 19c69f382baa13cac3bf36b861067bdc424e1be1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-21 09:27:17 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-21 09:50:20 +0900

    Merge RubyGems-3.6.3 and Bundler-2.6.3

commit 20a72bb6ec9cb27a91f00481de36fe5348296d8d
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2025-02-21 03:58:27 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-21 09:35:02 +0900

    [ruby/mmtk] Fix compatibility for Rust 1.85

    https://github.com/ruby/mmtk/commit/9da566e26a

commit f627efe8ae580d777d87c3bb8c0b350b49af62e8
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-02-18 02:57:54 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-19 02:14:05 +0900

    [ruby/prism] Fix escape unicode curly inline whitespace

    Fixes [Bug #21145]

    https://github.com/ruby/prism/commit/be2d845639

commit d2930f8e7a5db8a7337fa43370940381b420cc3e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-15 06:25:54 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-15 06:25:54 +0900

    v3.4.2

commit d5f42a07b26d4430c4c51ec3bb5bc482c68e9aca
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-02-15 04:20:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-15 04:41:55 +0900

    Fix locals_test based on previous backports

commit 62f736f23e9099c5aa29975dc7fbe2fe8c40b5b2
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-02-15 03:15:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-15 03:19:25 +0900

    Backport Bug #21137

commit eaa26b8c8c8de09daddbef131837a008963399dc
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-01-16 12:29:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-15 03:19:25 +0900

    Backport Bug #21118 and Bug #21043

commit 45fe3c137b6cc0b2546493e37d6334d8f39e076d
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2025-02-15 02:51:14 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-15 03:19:25 +0900

    Backport Bug #21031

commit 24f48c83e7e851a6ca712fc7b498634da9a24789
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-26 15:01:48 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:43:19 +0900

    [Bug #20982] Put spaces in `ENV.inspect` results as well as `Hash`

commit 80f2329f76b76ce7bd4fcd9a878b2bc5b0626b26
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-26 13:02:29 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:43:19 +0900

    Refine ENV tests

commit 270129fdcb923654d9741465ec26e179507e8c96
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:29:23 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:29:23 +0900

    merge revision(s) 19c39e4cfaa467e69b9848c9c5496d7f50d39c7f, d78ff6a767ca813ac5fa178dd7611f20a993c191: [Backport #20984]

            [Bug #20984] ENV.inspect should be encoding aware

            [Bug #20984] Fix test with locale encoding

commit de7a196bd4b22f6073e6cf6c2d7d6fd8171b6baa
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:20:21 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:20:27 +0900

    Revert "merge revision(s) cb419e3912f0514b8151469b0a4a4b83cbbcce78: [Backport #21031]"

    This reverts commit 7adf89d7ad30552d7e57709d24eec266f601d38b.

commit d5666bbf9191bb990096faa159ee2fb8d7c86f92
  Author:     Yuta Saito <kateinoigakukun@gmail.com>
  AuthorDate: 2025-02-12 20:43:05 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:19:01 +0900

    tool/downloader.rb: Stop caching already existing files

    Previously, the script was caching any file already present in the
    destination directory, regardless of its origin. This caused issues
    when the directory contained files copied from external sources like
    `autoreconf --install`.

    For example:
    1. `./autogen.sh --install` copies `config.guess` and `config.sub`
       from the system to `./tool`.
    2. `ruby tool/downloader.rb -d tool -e gnu config.guess config.sub`
       treats those files as if they were downloaded and caches them.
    3. Removing the files: `rm tool/config.guess tool/config.sub`.
    4. Running the downloader again, it mistakenly restores the cached
       files instead of downloading fresh versions.

commit 18daf8326a370d674b9e8aa6d124eafe1b53b847
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-01-16 18:02:16 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:19:01 +0900

    Use configu.guess with wasi compatible version

commit 9a0984436888a59f4914c3035c53657baf62ce2b
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:17:41 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:17:41 +0900

    merge revision(s) b21e1aed2ed5b22b50efc658289a403eeed581df: [Backport #21114]

            [ruby/prism] Fix infinite loop in error recovery

            When recovering from a depth error that occurs at the end of the
            file, we need to break out of parsing statements.

            Fixes [Bug #21114]

            https://github.com/ruby/prism/commit/a32e268787

commit d3fc56dcfa7b408cc3b6788efad36fd8df3e55da
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:17:04 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:17:04 +0900

    merge revision(s) 127325a4bad409ee5da91084fac768934a8fd9e3: [Backport #21117]

            [ruby/prism] No writing to numbered parameters

            Fixes [Bug #21117]

            https://github.com/ruby/prism/commit/19d4bab5a0

commit e3b16320e6b39e81606771f507278bf14045fa13
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:14:14 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:14:14 +0900

    merge revision(s) 91a10c07579f282a94e4b5830feaeca87f9a7dd3: [Backport #21112]

            Fix a typo in WeakKeyMap argument error

            [Bug #21112]

commit 319c3c70385a63aaea3c1a68a79c70cfd533c6b6
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:13:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:13:47 +0900

    merge revision(s) 1683dadb19876f0a64589bdbbcf6fff8143f78ff: [Backport #21088]

            Do not save ResolutionError if resolution succeeds for any address family (#12678)

            * Do not save ResolutionError if resolution succeeds for any address family

            Socket with Happy Eyeballs Version 2 performs connection attempts and name resolution in parallel.

            In the existing implementation, if a connection attempt failed for one address family while name resolution was still in progress for the other, and that name resolution later failed, the method would terminate with a name resolution error.
            This behavior was intended to ensure that the final error reflected the most recent failure, potentially overriding an earlier error.

            However, [Bug #21088](https://bugs.ruby-lang.org/issues/21088) made me realize that terminating with a name resolution error is unnatural when name resolution succeeded for at least one address family.

            This PR modifies the behavior so that if name resolution succeeds for one address family, any name resolution error from the other is not saved.

            This PR includes the following changes:

            * Do not display select(2) as the system call that caused the raised error, as it is for internal processing

            * Fix bug: Get errno with Socket::SO_ERROR in Windows environment with a workaround for tests not passing

commit e5403bd137d57991d8788cd29bbb5916d75acb36
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:12:33 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:12:33 +0900

    merge revision(s) db02a6b3ab4cabbdf492c26dcb1929b4ef0370a1: [Backport #21103]

            [Bug #21103] Fix local variable index calculation with forwarding

            Forwarding argument is optimized not to packed when no other arguments
            and an internal object refers values before it.  This size is decided
            at called time, calculate the local variable index from the fixed end
            point.

commit feb4a688a24a1966c8d08962a1104001234efcae
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:12:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:12:07 +0900

    merge revision(s) 46b544c54955348ef1ea9692b837b061f59f91cd, d3abee739f4feb91bb9aaae33877d70c8c576db0: [Backport #21095]

            Prefer `uname -n` over `hostname`. (#12647)

            Add fallback for `hostname` if `uname` isn't available. (#12655)

commit 2ee25f7b47a30b7515cdb4da341d28931d8b5810
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:11:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:11:06 +0900

    merge revision(s) 2b6fc9ea7212543a1be26768403f59c7a759b5ea: [Backport #21092]

            [Bug #21092] Fallback variables after execonf has done

            When reading from a dummy makefile, the global variables initialized
            in `init_mkmf` may not be overridden.

commit ead3bbc2405ad1df2228c44133ee1c6574ef5973
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:09:41 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:09:41 +0900

    merge revision(s) d4a1a2780c39bc648496ac92fc6e6ce2eb38ab47: [Backport #21032]

            rb_feature_p: skip `get_expanded_load_path` for absolute paths

            Ref: https://github.com/fxn/zeitwerk/pull/308

            ```ruby
            require 'benchmark'

            $LOAD_PATH << 'relative-path'

            autoload :FOO, '/tmp/foo.rb'

            puts Benchmark.realtime {
              500_000.times do
                Object.autoload?(:FOO)
              end
            }
            ```

            The above script takes 2.5 seconds on `master`, and only
            50ms on this branch.

            When we're looking for a feature with an absolute path, we don't
            need to call the expensive `get_expanded_load_path`.

commit 2108ab2cb68e9d975e4dcf035a11243e1173336f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:09:15 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:09:15 +0900

    merge revision(s) 04ec07794657cd2444ecb001a522b9df2db1b90a: [Backport #21038]

            Preserve `errno` in `rb_fiber_scheduler_unblock`. (#12576)

            [Bug #21038]

            Co-authored-by: Julian Scheid <julians37@gmail.com>

commit 3fdf7279a0b1ac35fdf233464a93b3d268133d5a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:08:44 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:08:44 +0900

    merge revision(s) e0d600ec190c64aff76cfcbd6009cffb927da166: [Backport #21012]

            Avoid opt_aset_with optimization inside multiple assignment

            Previously, since the opt_aset_with optimization was introduced,
            use of the opt_aset_with optimization inside multiple assignment
            would result in a segfault or incorrect instructions.

            Fixes [Bug #21012]

            Co-authored-by: Nobuyoshi Nakada <nobu.nakada@gmail.com>

commit 3db440f5a19ca8d46c2c5d5ec029dbae73cc34f9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:08:20 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:08:20 +0900

    merge revision(s) f7059af50a31a4d27a04ace0beadb60616f3f971: [Backport #21046]

            Use no-inline version `rb_current_ec` on Arm64

            The TLS across .so issue seems related to Arm64, but not Darwin.

commit 04298f2d158fa860293d2ed2779cba69bc47f404
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:07:57 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:07:57 +0900

    merge revision(s) c2908613368b2ae404d094a15df61d830fc46dc9: [Backport #21048]

            [ruby/prism] Fix rescue modifier precedence

            Fixes [Bug #21048]

            https://github.com/ruby/prism/commit/07202005cb

commit cd395232b0491f9c4463c5889bab8d2c050e75e2
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:07:25 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:07:25 +0900

    merge revision(s) 241ada7b1ca4fd71dc47a83d912ee25162a555d9: [Backport #21085]

            [ruby/prism] Do not put empty statements in while because of -n

            Fixes [Bug #21085]

            https://github.com/ruby/prism/commit/ebb9c36a10

commit 7adf89d7ad30552d7e57709d24eec266f601d38b
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:06:50 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:06:50 +0900

    merge revision(s) cb419e3912f0514b8151469b0a4a4b83cbbcce78: [Backport #21031]

            [PRISM] Handle forwarding inside eval

            Fixes [Bug #21031]

commit 579b94ae61d123dfb06caa2499be4ef6879cbf1f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 14:06:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 14:06:07 +0900

    merge revision(s) 931a870606f4e286a1c7bacf022940994f3c431b: [Backport #21044]

            [ruby/prism] Increase value of PRISM_DEPTH_MAXIMUM to 10000

            The previous value of 1_000 was added with a reference to the Bison
            parser[^1], but the value of YYMAXDEPTH in the Bison docs is 10_000,
            not 1_000.

            [^1]: https://www.gnu.org/software/bison/manual/html_node/Memory-Management.html

            Fixes [Bug #21044]

            https://github.com/ruby/prism/commit/e098533ab4

            Co-authored-by: Nony Dutton <nonydutton@gmail.com>

commit bc359b9971088ff921e26346f395c70640654e9e
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 11:01:42 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 11:01:42 +0900

    merge revision(s) b176d4f52e4af67654814dab3e9c5f4bf9170e54: [Backport #21008]

            [Bug #21008] Normalize before sum to float

            After switching to `Float`-mode when summing `Numeric` objects,
            normalization for `Float` is still needed.

commit b65cea74295358265dfabc9e1f4d107b21e58e58
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 11:01:20 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 11:01:20 +0900

    merge revision(s) 8034e9c3d001ca3dff124ab42972684eac8af2ae: [Backport #20995]

            [Bug #20995] Protect `IO.popen` block from exiting by exception

commit c989d90754edeefa4e692d2cd8c351394cb217e7
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:54:41 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:54:41 +0900

    merge revision(s) 117d6e145a0270ab8fc9134403519ef13b9ebb24: [Backport #21027]

            [ruby/prism] Fix `not` receiver

            `not foo` should be `!foo`
            `not()` should be `!nil`

            Fixes [Bug #21027]

            https://github.com/ruby/prism/commit/871ed4b462

commit 9240f01b1fbe5ea4f6a2017d35f8f605f84f0039
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:54:21 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:54:21 +0900

    merge revision(s) 63723c8d5908569918fb27e070ae5bc9de33c8bd: [Backport #21014]

            Correctly set node_id on iseq location

            The iseq location object has a slot for node ids.  parse.y was correctly
            populating that field but Prism was not. This commit populates the field
            with the ast node id for that iseq

            [Bug #21014]

commit c3d30e4dabb2b895c347e10221467dd1b1124ca4
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:53:47 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:53:47 +0900

    merge revision(s) 051af9529b03c11aff8f6a09522c69983e3a9d72: [Backport #21017]

            [Bug #21017] Fix `--with-parser` configure option

commit 698f808cc78b01bc23ff893eaabcc09a454b56ee
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:53:11 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:53:11 +0900

    merge revision(s) 5fec9308320e8b377681ef19b0cd46d53f94e8ac, 1a06bee027d5c5b65ed0aaee76ee0040554d4efd: [Backport #20992]

            [Bug #20992] Test for local variable name encodings

            Do not intern invalid symbols in eval parse

            When the inner code cannot represent the name of the locals in the
            outer code, do not bother putting them into the constant pool as
            they will not be referenced.

            Fixes [Bug #20992]

            Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit 82f7cb794109794f6ffa95ffb3be8e5149dd74bd
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:52:28 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:52:28 +0900

    merge revision(s) ad96c5a72908042489357b73dc936c4bc38d919b, ca81142eff98cccb03ff523322aefe4e7346fd0e: [Backport #21010]

            [ruby/prism] Throw syntax error for endless method with `[]=`

            Prism shoudld throw a syntax error for endless methods when the method
            name uses brackets. Previously it would not. This matches the behavior
            of parse.y.

            Fixes https://bugs.ruby-lang.org/issues/21010

            https://github.com/ruby/prism/commit/43c16a89ef

            [ruby/prism] [Bug #21010] Reject endless method definition of `[]=`

            Fixes: https://bugs.ruby-lang.org/issues/20785

            https://github.com/ruby/prism/commit/192960ce5d

commit 68013d43a35a8368caa7b30c501e270333d04b35
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:52:03 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:52:03 +0900

    merge revision(s) 31905d9e23ec6d1fa2a52f1ef2533f2056e7c9fb: [Backport #21001]

            Allow escaping from ensures through next

            Fixes [Bug #21001]

commit 8a86e52fb5fc49367e79f8f49fb451ab74e089bb
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:51:38 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:51:38 +0900

    merge revision(s) 668701cb0b42f27c5f54309a358c6fcbb24b5d85: [Backport #21002]

            Added copyright for vendored turbo_tests.

            [Bug #21002]

commit d720ea59ca36f726b8484b3b66e3e2c40784ac89
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:51:03 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:51:03 +0900

    merge revision(s) 2a1cff40f5e7875f69a7d0ed59eab92cc86c65ff: [Backport #21003]

            Do not warn unused block when using forwarding

            Fixes [Bug #21003]

commit 5ba052675f0eefe77dd7ab30bb9ac186f8d82ccb
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:50:05 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:50:05 +0900

    merge revision(s) fb18bb183c24ca82b8f114ed090d62bd69b5df84: [Backport #20989]

            [Bug #20989] Ripper: Pass `compile_error`

            For the universal parser, `rb_parser_reg_fragment_check` function is
            shared between the parser and ripper.  However `parser_params` struct
            is partially different, and `compile_error` function depends on that
            part indirectly.

commit 4bafaef0a55fdc45a7b8275a82ceb0f3e3419d00
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:47:24 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:47:24 +0900

    merge revision(s) 7df5d65eac86940619f87da7e70bc0911097ae2f: [Backport #20981]

            [Bug #20981] Bring back `rb_undefine_finalizer`

commit 294aef53b8c988f605001e4555d9532cefe8806d
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-01-09 09:07:07 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:46:14 +0900

    YJIT: Filter `&` calls from specialized C method codegen

    Evident with the crash reported in [Bug #20997], the C replacement
    codegen functions aren't authored to handle block arguments (nor
    should they because the extra code from the complexity defeats
    optimization). Filter sites with VM_CALL_ARGS_BLOCKARG.

commit 706f1d0573f0b807bee4c0cc8937b8f5b9b24ebd
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-01-29 06:13:28 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:44:58 +0900

    YJIT: Initialize locals in ISeqs defined with `...`

    Backport of GH-12660:

        Previously, callers of forwardable ISeqs moved the stack pointer up
        without writing to the stack. If there happens to be a stale value in
        the area skipped over, it could crash due to "try to mark T_NONE". Also,
        the uninitialized local variables were observable through `binding`.

        Initialize the locals to nil.

        [Bug #21021]

commit 12c716eea02f0efbb7dcd4ddb3a8b0523cdb99c2
  Author:     nick evans <nick@rubinick.dev>
  AuthorDate: 2025-02-11 23:03:02 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:44:25 +0900

    Bump net-imap to v0.5.6 for Ruby 3.4 (CVE-2025-25186)

    This update addresses CVE-2025-25186 (GHSA-7fc5-f82f-cx69).

commit 787436cd1ae00616b88bc494baaaee7c361f31b9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-07 11:02:42 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:42:41 +0900

    Support `git ls-files ...`.split style for file list of gemspec

commit 555373aec859413efd3237cf717931f4b7ac1cb1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-02-05 14:49:14 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:42:41 +0900

    Bump up net-smtp-0.5.1

commit 3c9e65d370f43b8eec99debad606964f80a935c5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2025-01-06 15:49:13 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:42:11 +0900

    glibc and musl didn't provide A1-A7, FP and S3-S8 constants.

    * https://sourceware.org/git/?p=glibc.git;a=blob;f=sysdeps/unix/sysv/linux/loongarch/sys/ucontext.h
    * https://git.musl-libc.org/cgit/musl/tree/arch/loongarch64/bits/signal.h

commit b5c921e01074891680b45353519a1e0bfe7c1036
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-01-14 19:11:33 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:40:19 +0900

    [Bug #21024] <cstdbool> header has been useless

    And finally deprecated at C++-17.
    Patched by jprokop (Jarek Prokop).

commit 73690b520da4c3ab680ddc477cacaeaeed75d558
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2025-01-05 01:41:00 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:37:38 +0900

    YJIT: Fix crash when yielding keyword arguments

    Previously, the code for dropping surplus arguments when yielding
    into blocks erroneously attempted to drop keyword arguments when there
    is in fact no surplus arguments. Fix the condition and test that
    supplying the exact number of keyword arguments as require compiles
    without fallback.

commit cefa630bce3aea8317f09fe73c6439f67c42bb69
  Author:     Nick Dower <nicholasdower@gmail.com>
  AuthorDate: 2025-01-03 01:24:55 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:37:38 +0900

    YJIT: Add crashing test for yielding keyword args

    Code like the following is crashing for us on 3.4.1:

    ```ruby
    def a(&) = yield(x: 0)

    1000.times { a { |x:| x } }
    ```

    Crash:

    ```
    ruby: YJIT has panicked. More info to follow...
    thread '<unnamed>' panicked at ./yjit/src/codegen.rs:8018:13:
    assertion `left == right` failed
      left: 0
     right: 1
    ```

    Co-authored-by: Dani Acherkan <dtl.117@gmail.com>

commit 65f2a4beecd3017ced366e3957eef501f2860c1f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2025-02-14 10:36:58 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2025-02-14 10:36:58 +0900

    Add k0kubun as CODEOWNERS

commit 48d4efcb85000e1ebae42004e963b5d0cedddcf2
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2024-12-25 16:43:20 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2024-12-25 16:43:20 +0900

    v3.4.1

commit f45010833071b953744658842369e3496dfacb48
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-25 13:50:41 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-12-25 13:50:41 +0900

    [DOC] Fix indentation for rdoc

commit 663f833bac04aa7ca16855d18a6bf6febd0597c5
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-25 13:49:52 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-12-25 13:49:52 +0900

    [DOC] Mention method argument optimization

commit e25b350fc57684e61583879aeaa2f3c1c8011847
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-25 13:42:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-12-25 13:42:06 +0900

    [DOC] Fix the broken format of RubyVM::YJIT.enable docs

commit 7245d3e3565d0744cb5e8f697b6721eaa700a4d6
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-25 13:36:12 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-12-25 13:36:12 +0900

    [DOC] Mention --yjit-perf=codegen in NEWS

commit 828e913cf7a98619ca1bdc29279dc72c1c81db17
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-25 13:31:02 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-12-25 13:31:02 +0900

    [DOC] Use the same indentation depth as adjacent sections

commit 1b0e362692fceea92c7431d4e6149debd46c7f0e
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2024-12-25 12:41:11 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2024-12-25 13:22:15 +0900

    [DOC] Fix typo in NEWS.md regarding thread-safety

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12465

commit bf878b54945e15e5bd36b8459ff48faeb242358a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-25 13:16:28 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-25 13:16:28 +0900

    [DOC] Ractor::RemoteError

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12467

commit 2acbf45d368e03f8a38906676b2e3e63f299c67d
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-25 13:16:14 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-25 13:16:14 +0900

    [DOC] Monitor

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12467

commit 871124c3ea9ccdc0e53efac73369786b494f6f96
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-25 13:07:22 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-25 13:07:22 +0900

    [DOC] Stop document Ripper::Lexer

    `:nodoc:` seems not working for inner classes.

commit e8aca1aafc16b458bb496e127133d8c4371c0816
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-25 12:00:00 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-25 12:00:00 +0900

    [DOC] Fix indentation

    RDoc markdown parser requires exact 4 spaces or tab as indentation.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12464

commit f72b94bdb68b6ebc16e8c9aa70ec9a1a9f259efc
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-25 11:37:37 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-25 11:37:37 +0900

    [DOC] Fix duplicate entries

    A tentative workaround for duplicate entries in "Class and Module
    Index".

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12463

commit 51d3f6459b2e2a381c8250dc3257c10db312c822
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-25 11:25:03 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-25 11:25:03 +0900

    [DOC] Hide Fiber::Pool

    It is experimental yet and is disabled currently.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12462

commit 92f850ae8428febb4d1d1754addf1045fbb4f71b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-25 11:13:07 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-25 11:13:07 +0900

    [DOC] Hide Ractor::Selector

    It is not enabled by default currently.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12461

commit 36e9028f9394a4415eca7c3db6a4b7f24531628f
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-25 11:00:06 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-12-25 11:00:06 +0900

    [DOC] Clarified YJIT stats changes

commit 4e4b87d324b0711180d99468ed40528abfd52db7
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-25 10:48:49 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-12-25 10:48:49 +0900

    [DOC] Categorize YJIT new features

commit e46314edd11d6807b603498150e0785c87d5d3a5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-25 10:30:40 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-25 10:30:40 +0900

    [DOC] Monitor

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12460

commit 8aac08498ba7ad915eaf614fb0ceec8480a0b3ac
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-25 08:46:15 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-25 08:46:15 +0900

    Update bundler version on NEWS.md

commit 468b7af67e5ea2f7308581115d4c4eb6d4d45556
  Author:     Alan Wu <alanwu@ruby-lang.org>
  AuthorDate: 2024-12-25 05:40:57 +0900
  Commit:     Alan Wu <alanwu@ruby-lang.org>
  CommitDate: 2024-12-25 05:40:57 +0900

    [DOC] RegExp: The Graph property includes some control characters

    The behavior of this is a carry-over from Oniguruma:
      https://github.com/kkos/oniguruma/blob/5eaee9f5f8f674aff4875c2b35db00758fa349d6/doc/RE#L246

    The previous phrasing was inaccurate since it's fair to construe e.g.
    Zero Width Joiner as a control character.

    Reported-by: https://github.com/ruby/ruby/pull/12294

commit 372e19bbb50efd6f2744450cde30b25fadbf0b5b
  Author:     tomoya ishida <tomoyapenguin@gmail.com>
  AuthorDate: 2024-12-25 04:29:42 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-25 04:29:42 +0900

    [DOC] Add IRB's new completion section to NEWS.md

    * Fix link and copyedit blurb

    Co-authored-by: Alan Wu <XrXr@users.noreply.github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12458

    Merged-By: XrXr

commit 645d604766d8df32d8dcae04dbfe7e5f7a382e4f
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2024-12-25 01:40:22 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2024-12-25 04:02:00 +0900

    Fix missing/broken links in NEWS.md

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12456

commit 58460b4dbd44328aefa6960fefd940e28034023b
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2024-12-25 03:49:55 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-25 03:49:55 +0900

    [DOC] Adjust documentation related to backtraces (#12420)

  Notes:
    Merged-By: zverok <zverok.offline@gmail.com>

commit 3be1baab82d8627ce52391030160bcbca69db01d
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2024-12-25 03:06:02 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-25 03:06:02 +0900

    Introduce a timeout to prevent `rb_thread_fd_select` from hanging with write(2) failure (#12457)

    Rarely, there are cases where a write(2) call from a child thread
    to notify the main thread of the completion of name resolution fails.
    If this happens while the main thread is waiting in `rb_thread_fd_select`,
    rb_thread_fd_select may not notice that the name resolution has completed and end up hanging.

    This issue becomes a problem when there are no sockets currently being connected,
    no addresses ready for immediate connection attempts,
    and name resolution has already completed for one address family
    while the main thread is waiting for the name resolution of the other address family.
    (If name resolution is not completed for either address family,
    the chances of write(2) failing in both child threads are likely low.)

    To avoid this issue, a timeout is introduced to rb_thread_fd_select under the above conditions.
    This way, even if the issue occurs,
    the completion of name resolution should still be detected
    in the subsequent `if (!resolution_store.is_all_finished) ...` block.

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit 07e89bde4693fa6b8da4c152f1cf91686d1823f1
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-24 00:55:49 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-24 23:40:12 +0900

    Fix MEMMOVE in rb_darray_insert

    Ruby's MEMMOVE takes in the element data type for the third argument, not
    the size of the element. What this did was do sizeof(sizeof( ... )) which
    always returned sizeof(size_t).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12442

commit 13e6fe9bbc9dd251f6c71cb5130a7a83b415134b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-24 21:31:52 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-24 21:31:52 +0900

    [DOC] Hide `RubyVM::Shape` that is for debug from RDoc totally

commit 94df8a0cae1aa8bd7ebcd689437fd3276777a2b0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-24 16:23:37 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2024-12-24 17:50:01 +0900

    Postpone spec of eszett with ignore case in look behind

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12455

commit 737ca6b83dbba5167f012bc41740973aca7e6fb6
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2024-12-24 17:10:43 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-24 17:10:43 +0900

    Bundle rbs-3.8.0 (#12453)

  Notes:
    Merged-By: soutaro <matsumoto@soutaro.com>

commit 1b0c46daed9186b82ab4fef1a4ab225afe582ee6
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-24 13:06:44 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-24 13:27:05 +0900

    [Bug #20979] [DOC] Add a proviso to `+comment` option

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12450

commit fb82f3a632fa07dd270ed188cd6ce751ecabcb84
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-24 11:42:15 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2024-12-24 13:25:55 +0900

    Win32: Defer change of timezone name encoding after 3.4

    This change will be merged into 3.5 along with other encoding, command
    line, environment variables, etc.

    Revert following commits:

    - bd831bcca534955533d9135d8c2f22d7ae5b9aa8
      [Bug #20929] Win32: Use `wcsftime`

    - 1c15f641cc2bb88fa88123a11036ed58fbf9aa6d
      [Bug #20929] Win32: Encode timezone name in UTF-8

    - 78762b52185aa80ee55c0d49b495aceed863dce2
      [Bug #20929] Fix `assert_zone_encoding`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12448

commit 42026ec3da6acb2c398bea8c8dc97103a7c936ec
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-23 20:24:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-24 12:07:54 +0900

    Fix bundled gems warning for sub feature locations

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12439

commit 0d81177c2013b0a596eb4caebe0bcca557144139
  Author:     lukeg <luke.gru@gmail.com>
  AuthorDate: 2023-04-05 05:24:59 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2024-12-24 11:40:00 +0900

    Fix calls to require_internal in multi-ractor mode

    After a ractor is started (multi-ractor mode), any calls to
    require_internal will hang the process due to deadlock. For example,
    loading a new encoding will deadlock after a ractor starts.

    Fixes [Bug #19562]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/7656

commit 38af38edcbceb9d17aaf84420008fe839f77e42f
  Author:     Luke Gruber <luke.gru@gmail.com>
  AuthorDate: 2024-02-17 04:08:39 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2024-12-24 11:38:44 +0900

    Fix ractor move of unshareable frozen objects

    These objects didn't retain their frozen status after the move

    Bug [#19408]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/9996

commit 1eb5c03fda7e9616a1461f48f4bd8b8739de122d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-24 11:38:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-24 11:38:05 +0900

    Added previous version or prime

commit ed7ed25e6ea66ae7a95755811f9ecac67bc480f4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-24 11:27:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-24 11:27:37 +0900

    Update RubyGems, Bundler and missing histories of minitest and typeprof

commit ab8fd5bb6cdb9c661673f2edf0546ff3a63fe189
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2024-12-24 09:57:11 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2024-12-24 10:47:20 +0900

    not a incompatbile, but a feature

    The change of `Object#singleton_method` doesn't harm existing code
    so it should be new feature (bug fix).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12446

commit 2a08f7283ed2ca18e25f4b4d19d2f5c6b450c574
  Author:     Luke Gruber <luke.gru@gmail.com>
  AuthorDate: 2024-12-24 03:37:56 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2024-12-24 09:05:49 +0900

    Fix [Bug #20779] Dedicated native thread creation failed bug

    When a dedicated native thread fails to create (OS can't create more
    threads), don't add the ruby-level thread to the thread scheduler. If
    it's added, then next time the thread is scheduled to run it will sleep
    forever, waiting for a native thread that doesn't exist to pick it up.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12441

commit 9e0eb9778d557ef59a541a65be658040951de5be
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-24 05:02:37 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-24 07:21:10 +0900

    Merge RubyGems-3.6.2 and Bundler-2.6.2

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12444

commit 527cc7328207de06750debf4c6bfce81a897957d
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-24 07:12:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-24 07:12:08 +0900

    YJIT: Return None if entry block compilation fails (#12445)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 5b22f14e5366738336ca880d0efaf05b6cf90961
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-24 04:57:37 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-24 06:44:30 +0900

    GC guard the iseq in eval for prism

    We need to GC guard the iseq because the code above it malloc memory which
    could trigger a GC. Since we only use ISEQ_BODY, the compiler may optimize
    out the iseq local variable so we need to GC guard it.

    Fixes: http://ci.rvm.jp/results/trunk_asan@ruby-sp1/5484752

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12443

commit f4476f0d07c781c906ed1353d8e1be5a7314d6e7
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-21 06:48:48 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-23 23:03:32 +0900

    Disable GC during RUBY_INTERNAL_EVENT_NEWOBJ

    We must disable GC when running RUBY_INTERNAL_EVENT_NEWOBJ hooks because
    the callback could call xmalloc which could potentially trigger a GC,
    and a lot of code is unsafe to trigger a GC right after an object has
    been allocated because they perform initialization for the object and
    assume that the GC does not trigger before then.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12419

commit 4e12c2577839bd1696a3b318988be1c4de807d48
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-23 21:53:47 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-23 21:53:47 +0900

    [DOC] Fix indentation

    RDoc markdown parser requires exact 4 spaces or tab as indentation.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12440

commit 376ef474debf4faa38725d12d20af010822ee212
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2024-12-23 20:08:18 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2024-12-23 20:40:03 +0900

    Bundle TypeProf 0.30.1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12437

commit 1aba05f370cc227c40159c026476435b28da5da1
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2024-12-23 17:38:39 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2024-12-23 20:40:03 +0900

    Check if TypeProf 0.30.1 (planned) passes the CI

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12437

commit bf5f8ecef1e95ba94ecbb64dc2766f1639194243
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-23 19:21:46 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-23 19:21:46 +0900

    [Bug #20978] Use `ruby_bug` instead of `ruby_version_is`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12438

commit adad97a0310ebcd749e906be48bdabe9740deddf
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-23 18:16:28 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-23 18:16:28 +0900

    [Bug #20978] Stringize Fiber storage keys

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12438

commit a11bb36316fa4e2a63e58ca03c44dca7ad93a32f
  Author:     zzak <zzakscott@gmail.com>
  AuthorDate: 2024-12-23 17:37:47 +0900
  Commit:     zzak <zzakscott@gmail.com>
  CommitDate: 2024-12-23 17:37:47 +0900

    Add more back quotes for code and fix missing feature#20018 link

commit 49de9078c7ab7864f2ef8544ee7c3e16047ffe23
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-23 16:39:47 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-23 16:39:47 +0900

    Added version histories for csv, net-imap, power_assert and rbs

commit 4de6680a88ba6610489d9fc21152969e49da6e23
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-23 16:21:27 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-23 16:21:27 +0900

    Added limitation of bundled_gems.rb with sub-feature example

commit 3cbfd2191617a36d55d6b46bc01325114bea58f1
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-21 03:14:46 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-23 16:01:30 +0900

    Fix code location in bundled gems warnings

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12412

commit 62a727536cb702269d34fe0cf70c4374af63c068
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-21 03:14:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-23 16:01:30 +0900

    Fix spec description

    We're actually expecting the warning to not be displayed here.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12412

commit a51b5660dce898cf96f7f6ea74f015e17c355e84
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-21 03:13:00 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-23 16:01:30 +0900

    Find uplevel for bundled gems warnings just once

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12412

commit a6253c15adf4072adf46f114aa0eee29fbdcc77b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-23 14:58:09 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-23 15:49:30 +0900

    Update bundled_gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12436

commit d8c152eeadb518d6a757fe1fccf70d8941519cfb
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2024-12-22 23:12:35 +0900
  Commit:     yui-knk <spiketeika@gmail.com>
  CommitDate: 2024-12-23 15:16:32 +0900

    Lrama v0.6.11

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12429

commit 34e6bb48af2814eefd91968c58c1dede3b56f30e
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2024-12-23 15:05:00 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-23 15:05:00 +0900

    Improve doc for `Socket::ResolutionError` (#12434)

    Also, a topic about Socket::ResolutionError is added to NEWS

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit f2d1c3d3ce80e895b3295443c6bd3d63647d7d04
  Author:     Kazuki Tsujimoto <kazuki@callcc.net>
  AuthorDate: 2024-12-23 15:01:20 +0900
  Commit:     Kazuki Tsujimoto <kazuki@callcc.net>
  CommitDate: 2024-12-23 15:01:20 +0900

    [DOC] Fix a typo in NEWS.md

commit 8947e53bd6119d7bfd4896d2c2082079b918f281
  Author:     Kazuki Tsujimoto <kazuki@callcc.net>
  AuthorDate: 2024-12-23 14:56:01 +0900
  Commit:     Kazuki Tsujimoto <kazuki@callcc.net>
  CommitDate: 2024-12-23 14:57:58 +0900

    Update power_assert to 2.0.5

commit 18580bc4e0296dac77d583c037f6346441773e02
  Author:     yui-knk <spiketeika@gmail.com>
  AuthorDate: 2024-12-23 13:58:25 +0900
  Commit:     yui-knk <spiketeika@gmail.com>
  CommitDate: 2024-12-23 14:53:51 +0900

    Add a test case for nested block `it`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12435

commit bd569cb7081e11628ee637ce9364d56c653c932c
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2024-12-23 12:30:55 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2024-12-23 14:07:19 +0900

    add back quotes for method/class names

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12433

commit 667a0f9f928be843a0810f2c61b633be1f8cd46a
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-23 13:46:50 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-23 13:46:50 +0900

    Revert "[Bug #20965] Define `it` like an ordinary argument" (#12418)

    Revert "[Bug #20965] Define `it` like an ordinary argument (#12398)"

    Reverts [ruby/ruby#12398](https://github.com/ruby/ruby/pull/12398) as per https://bugs.ruby-lang.org/issues/20970#note-6 and https://bugs.ruby-lang.org/issues/20965#note-7.
    We need more time to design the intended behavior, and it's too late for Ruby 3.4.

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit b19fcd02fae7bea162c6f1cee371a4b024305be7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-02 22:38:24 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2024-12-23 11:52:14 +0900

    Use the dedicated constants `LIBARG` and `LIBPATHFLAG`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/9815

commit be7e5f1f85685a757bea6c8dae4e30914a5eec67
  Author:     Julien Marrec <julien.marrec@gmail.com>
  AuthorDate: 2024-02-02 17:40:38 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2024-12-23 11:52:14 +0900

    Implements [Feature #3456]: Support pkgconf on windows

    1. Store the `PKG_CONFIG` variable in Makefile.sub (or try to get it from the ENV var PKG_CONFIG in mkmf.rb)
    2. Try to use --msvc-syntax, with a fallback to replacing -Lxxx with -libpath:xxx. --msvc-syntax has been in pkgconf since 1.4.0 (released 7 years ago). pkg-config (freedesktop), does not support it, hence the fallback.
    3. The `try_ldflags` passes these `ldflags` as the `opt` parameter to the `link_command`, not as `ldflags`. Unix systems are forgiving in that regard, MSVC is not: as a result as passing them as `opt`, they (specifically the `/libpath:xxx` ones) end up passed before the `-link` command to `cl.exe` and it throws because it ignores it and therefore can't find the lib.

    ```
    cl : Command line warning D9002 : ignoring unknown option '-libpath:C:/Users/julien/.conan2/p/libff3726d89a6255c/p/lib'
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/9815

commit c695536cc8ea4be69849394b0c64c974d52c603a
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2024-12-20 17:42:53 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2024-12-23 11:05:34 +0900

    use `st_update` to prevent table extension

    to prevent the following scenario:

    1. `delete_unique_str()` can be called while GC (sweeping)
    2. it calls `st_insert()` to decrement the counter
    3. `st_insert()` can try to extend the table even if the key exists
    4. `xmalloc` while GC and cause BUG

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12407

commit 60c814607d5a1cc0522303cfe8378183a427dd79
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-23 09:39:06 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-23 09:39:08 +0900

    Omit TestEval#test_outer_local_variable_under_gc_compact_stress with s390x

commit af903a77d7d39ba353769dd67ee7c7d12a75b28d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-23 07:10:37 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-23 09:08:13 +0900

    Update bundled_gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12431

commit 0ea0b1a15d2c926be3f474f3024f90929b35fb74
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-22 23:42:40 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-22 23:42:40 +0900

    [DOC] Update about optional dump flags

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12430

commit f7ce62cc5b2a7465add04fa2c49fb1068b3bb42b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-22 23:14:03 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-22 23:14:03 +0900

    Add `hello`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12427

commit 354e790794d9fd4996172da9235e3b09fcb3e4ca
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-20 16:48:35 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-22 22:10:27 +0900

    Simplify MODULAR_GC_DIR setting

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12428

commit fca85845ab3ee12b9d1907a1335aa3f18bf322f7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-20 16:48:09 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-22 22:10:26 +0900

    Install modular GC libraries

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12428

commit e1ff13b1465cc548ff1f9416c22492e6177d59a3
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-20 16:46:57 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-22 22:10:26 +0900

    modular-gc-precheck for mswin

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12428

commit 4fb5d746ce02dcaf8702f97f88946c090b65d4a2
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-20 16:44:27 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-22 22:10:26 +0900

    Split `modular-gc` into build and installation

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12428

commit 2f2530b195008209e1d9e4e9734509d5f956fa49
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-20 16:41:58 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-22 22:10:26 +0900

    Allow variables in modular_gc_dir

    Such as `$(ruby_version)`, `$(arch)` and so on.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12428

commit 626037e143886bb5d15b3c5ebf1e04fc711407fa
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-09-30 11:24:22 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-22 22:10:26 +0900

    Support RUBY_MODULAR_GC with LOAD_RELATIVE

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12428

commit 99d5e6ab7a8a6cf42a75e5b29c396f670259b9c1
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-20 01:09:15 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-22 22:10:02 +0900

    Suppress WIN32OLE deprecation warnings for the time being

commit cd8ad9634d9ab93f813d23b92384e04ecb8cc5f9
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2024-12-22 17:39:19 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2024-12-22 18:09:02 +0900

    s/Punctation/Punctuation/

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12426

commit b8fe5550e7e0e623805a954b148286bda2b38ecd
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2024-12-22 17:39:00 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2024-12-22 18:09:02 +0900

    s/backslashs/backslashes/

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12426

commit b0d40d3d039d50afd6ca7e95f77cfb3932a50b69
  Author:     Yudai Takada <t.yudai92@gmail.com>
  AuthorDate: 2024-12-22 18:08:39 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-22 18:08:39 +0900

    [DOC] Fix typos in comments in ractor.c

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12425

    Merged-By: nobu <nobu@ruby-lang.org>

commit 3808d29e2001c374f3bcda32a42519d6c28e5d09
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2024-12-22 03:33:13 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2024-12-22 15:08:19 +0900

    Fix extra 'warning:' prefix for chilled Symbol#to_s

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12423

commit e76d2fddad7829ad5e2d36455b68e1025bbfbf33
  Author:     zverok <zverok.offline@gmail.com>
  AuthorDate: 2024-12-22 03:23:43 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2024-12-22 15:07:56 +0900

    [DOC] Fix typo in related class reference

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12422

commit 9e3e1c7fc9dddb61de4867ad786e86958d11b33c
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2024-12-18 23:04:35 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2024-12-22 03:33:03 +0900

    [ruby/openssl] Ruby/OpenSSL 3.3.0

    https://github.com/ruby/openssl/commit/e5153dbbb4

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12421

commit 2a3f2412b704cfd4eb34c90e2032e3e2d40d3ae2
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2024-12-20 20:48:54 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2024-12-22 03:33:03 +0900

    [ruby/openssl] ssl: fix flaky test case test_ctx_client_session_cb_tls13_exception

    In the test case, the client raises an exception in the session_new_cb
    and may not cleanly close the connection. Let's ignore exceptions raised
    at the server side.

    Fixes: https://github.com/ruby/openssl/issues/828

    https://github.com/ruby/openssl/commit/210ba0334a

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12421

commit 486246209777ca36cd7d2620368c5b455f113910
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2024-12-11 01:42:57 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2024-12-22 03:33:03 +0900

    [ruby/openssl] digest: remove optional parameter from OpenSSL::Digest#finish

    OpenSSL::Digest#finish overrides Digest::Instance#finish and is called
    from the Digest::Class framework in the digest library. This method is
    not supposed to take any arguments, as suggested by the RDoc comment for
    Digest::Instance#finish.

    It is a private method and not exposed to users. Let's remove it.

    This optional parameter exists since r15602 in Ruby trunk, the commit
    which converted OpenSSL::Digest to a subclass of Digest::Class.

    https://github.com/ruby/openssl/commit/dcb2a4f30b

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12421

commit 9de2b407d7034b81963f8c5663233d353356d6cc
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2024-12-11 00:59:37 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2024-12-22 03:33:03 +0900

    [ruby/openssl] digest: make output buffer String independent in #finish

    Likewise, OpenSSL::Digest#finish needs to make the output buffer
    independent before writing to it.

    https://github.com/ruby/openssl/commit/9cc8a83466

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12421

commit 637f019f1f7611ba41f761a1b17e4228661d0a5b
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2024-12-10 23:06:00 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2024-12-22 03:33:03 +0900

    [ruby/openssl] cipher: make output buffer String independent

    OpenSSL::Cipher#update accepts a String as the second argument to be
    used as the output buffer. The buffer must be directly writable, in
    other words, it must not be frozen and not a shared string.

    rb_str_resize() does not make the String independent if the String
    already has the intended length. Use the rb_str_modify() family instead
    to check it.

    Fixes: https://bugs.ruby-lang.org/issues/20937

    https://github.com/ruby/openssl/commit/1de3b80a46

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12421

commit c79b4354074742ca1cbbb25a4f04bbffeb58407d
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2024-07-03 19:40:07 +0900
  Commit:     Kazuki Yamaguchi <k@rhe.jp>
  CommitDate: 2024-12-22 03:33:03 +0900

    [ruby/openssl] pkcs12: add PKCS12#set_mac

    Add a binding for PKCS12_set_mac() to set MAC parameters and
    (re-)calculate MAC for the content.

    This allows generating PKCS #12 with consistent MAC parameters with
    different OpenSSL versions. OpenSSL 3.0 changed the default hash
    function used for HMAC and the KDF from SHA-1 to SHA-256.

    Fixes: https://github.com/ruby/openssl/issues/772

    https://github.com/ruby/openssl/commit/f5ed2a74b6

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12421

commit 78f55ccd9be6c1893f07c841843a75f3b988dcf2
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2024-12-22 03:06:48 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-22 03:06:48 +0900

    [DOC] Move Time#xmlschema docs to the core (#12403)

  Notes:
    Merged-By: zverok <zverok.offline@gmail.com>

commit efe671f9d3de51c9c391a5de4ec3d32766b35079
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2024-12-22 03:05:26 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-22 03:05:26 +0900

    Properly document Ractor#require (#12389)

  Notes:
    Merged-By: zverok <zverok.offline@gmail.com>

commit 6114094aa049ffcf3202254933e5da1552837c32
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-21 10:45:51 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-12-21 10:45:52 +0900

    [DOC] Resurrected YJIT section

    under "Implementation improvements", similarly to past versions.

    We also don't do categorization like "* New features" (which was in this
    file) or "New features:" (which was on the release notes), so I used the
    standard header format instead.

    I applied the same change to release notes, copied the same thing back
    to NEWS.md, and then removed the TL;DR section from it.

commit 861ee7a3212d5e3e794d08034062fd4c21cac2a9
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-21 10:33:08 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2024-12-21 10:40:33 +0900

    [DOC] Reorder Language changes entries a little

    Warnings aren't something to brag first on the release notes. So I
    lowered the string literal one just a little. However, it still seems
    significant compared to other Bug tickets and incompatibilities/warnings,
    so I still kept it relatively high.

commit 018b77503936370174d30b5c8cb2473d55fc35dd
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2024-12-20 09:13:18 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2024-12-21 07:21:57 +0900

    FREE_AT_EXIT: Free all allocations from fiber pool

    The fiber pool allocations form a singly-linked list, so when we're
    running with RUBY_FREE_AT_EXIT we need to walk the linked list freeing
    each element, otherwise it can be detected as a memory leak.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12405

commit 36966456c728b4faba8aa7c853cdccdfcf9a14ab
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-21 04:33:16 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-21 06:52:36 +0900

    GC guard lookup_name

    When searching for native extensions, if the name does not end in ".so"
    then we create a new string and append ".so" so it. If the native extension
    is in static_ext_inits, then we could trigger a GC in the rb_filesystem_str_new_cstr.
    This could cuase the GC to free lookup_name since we don't use the local
    variable anymore.

    This bug was caught in this ASAN build:
    http://ci.rvm.jp/results/trunk_asan@ruby-sp1/5479182

        ==435614==ERROR: AddressSanitizer: use-after-poison on address 0x715a63022da0 at pc 0x5e7463873e4e bp 0x7fff383c8b00 sp 0x7fff383c82c0
        READ of size 14 at 0x715a63022da0 thread T0
            #0 0x5e7463873e4d in __asan_memcpy (/tmp/ruby/build/trunk_asan/ruby+0x214e4d) (BuildId: 607411c0626a2f66b4c20c02179b346aace20898)
            #1 0x5e7463b50a82 in memcpy /usr/include/x86_64-linux-gnu/bits/string_fortified.h:29:10
            #2 0x5e7463b50a82 in ruby_nonempty_memcpy /tmp/ruby/src/trunk_asan/include/ruby/internal/memory.h:671:16
            #3 0x5e7463b50a82 in str_enc_new /tmp/ruby/src/trunk_asan/string.c:1035:9
            #4 0x5e74639b97dd in search_required /tmp/ruby/src/trunk_asan/load.c:1126:21
            #5 0x5e74639b97dd in require_internal /tmp/ruby/src/trunk_asan/load.c:1274:17
            #6 0x5e74639b83c1 in rb_require_string_internal /tmp/ruby/src/trunk_asan/load.c:1401:22
            #7 0x5e74639b83c1 in rb_require_string /tmp/ruby/src/trunk_asan/load.c:1387:12

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12414

commit 391b6746cdc3fa39d1a5d832debe9c5b5dc39f51
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2024-12-21 05:47:10 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2024-12-21 06:45:28 +0900

    Provide Ractor support for **

    Fixes [Bug #20916]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12417

commit 97f55466760d89a54e82608e5c7c31fba60158ca
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-21 04:09:19 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-21 05:04:08 +0900

    Don't print bug report in asan_death_callback when no VM

    If we don't have the VM (e.g. printing memory leaks in LSAN after shutdown)
    then we will crash when we try to print the bug report. This issue was
    reported in: https://github.com/ruby/ruby/pull/12309#issuecomment-2555766525

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12413

commit aa360c3bee359f456d2f72dfa1bc9767074587ae
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2024-12-21 04:48:12 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2024-12-21 04:51:53 +0900

    [DOC] Fix to GC.config docs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12415

commit 07724d7b6f96f3758c64d7cede3c72b5b317e41e
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2024-12-21 01:30:23 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2024-12-21 04:47:01 +0900

    [DOC] Document the :implementation key of GC.config

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12411

commit 5d1fde06d489893a846bf0e69d18d958a827c27c
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2024-12-21 03:57:02 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-21 03:57:02 +0900

    [DOC] Refresh standard libraries page (#12404)

    * Migrate standard library doc page to markdown

    * Improve libraries listing and link to source code

    * Fix grammar and improve phrasing

    Co-authored-by: Jeremy Evans <code@jeremyevans.net>

  Notes:
    Merged-By: jeremyevans <code@jeremyevans.net>

commit 83a34fb060aa0cbd569d747ceecddd8fd6e50ed2
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2024-12-19 02:01:10 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2024-12-21 03:55:36 +0900

    [DOC] Don't document gemspec files

    Since https://github.com/ruby/ruby/commit/cf711863cbe0b81be5ff0adfb64936137995cc4e, gemspecs are included because the default exclude is overwritten

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12386

commit e23a60b929cff951252167935e8868b69ae3dc74
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-18 04:14:36 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2024-12-20 22:24:54 +0900

    Fix GC compaction crash when using local variables in eval

    If we have local variables outside of the eval, the local variables names
    are IDs. We convert these IDs to char * using rb_id2name. However, these
    char * are actually Ruby strings, which may be embedded. This means that
    it is not safe to rb_id2name and call any potential GC entrypoints because
    if a GC compaction runs, the embedded string may move and the pointer will
    change.

    For example, if you compile with `-DRGENGC_CHECK_MODE=1`, then the following
    script will crash:

        GC.auto_compact = :empty
        GC.stress = true

        o = Object.new

        eval("def o.m(k: 0) k end")

    The crash message is:

        test.rb:6: [BUG] Local with constant_id 1 does not exist
        ruby 3.4.0dev (2024-12-17T18:34:57Z prism-local-compac.. 434346726c) +PRISM [arm64-darwin24]

        -- C level backtrace information -------------------------------------------
        miniruby(rb_print_backtrace+0x24) [0x10312fec4] vm_dump.c:823
        miniruby(rb_print_backtrace) (null):0
        miniruby(rb_vm_bugreport+0x2d4) [0x1031301b8] vm_dump.c:1155
        miniruby(rb_bug_without_die_internal+0xa8) [0x102dd6a94] error.c:1097
        miniruby(rb_bug+0x28) [0x102dd6b00] error.c:1115
        miniruby(pm_lookup_local_index+0xec) [0x102d61e4c] prism_compile.c:1237
        miniruby(pm_compile_node+0x45d0) [0x102d252f4] prism_compile.c:9334
        miniruby(pm_compile_node+0x1864) [0x102d22588] prism_compile.c:8650
        miniruby(pm_compile_node+0x65ec) [0x102d27310] prism_compile.c:9897
        miniruby(pm_compile_scope_node+0x3008) [0x102d77bcc] prism_compile.c:6584
        miniruby(pm_compile_node+0x5ec4) [0x102d26be8] prism_compile.c:9768
        miniruby(pm_iseq_compile_node+0xac) [0x102d20bf0] prism_compile.c:10069
        miniruby(pm_iseq_new_with_opt_try+0x2c) [0x102e7d088] iseq.c:1029
        miniruby(rb_protect+0x108) [0x102dea9bc] eval.c:1033
        miniruby(pm_iseq_new_with_opt+0x264) [0x102e7c444] iseq.c:1082
        miniruby(pm_iseq_new_eval+0xec) [0x102e7c8e0] iseq.c:961
        miniruby(pm_eval_make_iseq+0x594) [0x1031209cc] vm_eval.c:1770
        miniruby(eval_make_iseq+0x54) [0x103120068] vm_eval.c:1799

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12374

commit 85f3ed8cdbc4c106033b81021a9957ced6a94311
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-18 03:34:57 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2024-12-20 22:24:54 +0900

    Don't recompute the strlen in pm_eval_make_iseq

    We've already computed the length of the string, so we can reuse it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12374

commit e8d393c8ae0c6282262b7a7886947379a9fd81a3
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2024-12-20 18:52:11 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2024-12-20 22:19:57 +0900

    [PRISM] Treat it as a local when compiling patterns

    Fixes [Bug #20973]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12408

commit 0397bfa2c83f442cb46dd0219d30c52aa7ff6d16
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2024-12-20 15:37:10 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2024-12-20 22:19:09 +0900

    [PRISM] Fix compiling popped opt_str_uminus and opt_str_freeze

    Put a pop as needed. This example currently causes [BUG]:

            $ ruby --parser=prism -e'1.times{"".freeze;nil}'
            -e:1: [BUG] Stack consistency error (sp: 15, bp: 14)
            ruby 3.4.0dev (2024-12-20T00:48:01Z master 978df259ca) +PRISM [x86_64-linux]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12410

commit b53a75230feb1db64320545ae45514ebd8d4c535
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2024-12-20 18:55:26 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-20 18:55:26 +0900

    Fix tests for fast_fallback (#12406)

    * TCPSocket.new: Close resources in ensure

    * TCPSocket.new: Remove unnecessary comments

    * Socket.tcp: Make assert_separately in TestSocket more readable

    * Socket.tcp: Returning instead of exiting

    * Socket.tcp: Close resources in ensure

    * Socket.tcp: Avoid test failures on hosts that only support IPv4

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit 2f6c694977dc0cdc4766a8a921e74290963c19a7
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2024-12-19 07:10:04 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2024-12-20 16:49:30 +0900

    Memerror is fatal if VM cannot be unlocked.

    [Bug #20942]

    If we've raised a memerror while the VM is locked, and the tag we're
    jumping to has been locked at a different level to the current lock (ie.
    we've locked the VM again since the tag we're jumping to) then we should
    consider this memerror fatal and exit, since the tag cannot unlock the
    VM.

    Co-Authored-By: Peter Zhu <peter@peterzhu.ca>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12393

commit 978df259ca90c25ca2acb95a099ff6d3ff0161b0
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2024-12-20 09:48:01 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-20 09:48:01 +0900

    Bundle rbs-3.8 (#12399)

    * Clean up skip tests

    * Bundle rbs-3.8.0.pre.1

  Notes:
    Merged-By: soutaro <matsumoto@soutaro.com>

commit 2a44a57e1455302fc90c94cf02ff89c9f3bcf5d2
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2024-12-19 05:36:59 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2024-12-20 07:15:23 +0900

    [DOC] Link to special `fatal` class through `rdoc-ref`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12391

commit 33f95d632dce42fac35da29eaed33f0a5a4f0dcb
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-20 03:52:01 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-20 06:25:23 +0900

    Don't unpoison the CC in vm_ccs_free

    The poison status is maintained by the GC, so don't unpoison it in vm_ccs_free.
    If the object is not a garbage object, then it should not be poisoned.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12402

commit 84eff67644aa0dabb996daf68eb060c2f3f5c7bb
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-20 03:12:16 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-20 03:20:31 +0900

    [DOC] Add gc/README.md

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12379

commit 5978f2f114a5a669a39cdc46c457a3ea8ee24056
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2024-12-20 02:28:21 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-20 02:28:21 +0900

    Fix use-after-free in vm_ccs_free()

    `struct rb_callcache *` point to an imemo object on the GC heap when
    pushed into `struct rb_class_cc_entries`, but by the time vm_ccs_free()
    runs, the entire GC page the imemo was on could already be deallocated.
    With the right conditions, vm_ccs_free() wrote to freed memory.
    rb_objspace_garbage_object_p() by itself is not enough to determine
    liveness.

    I conjectured this situation to be possible in
    <https://github.com/ruby/ruby/pull/11995> using hints from crashes
    in the wild. With c37bdfa5311be0aa8503b995299fb9547cede0a6 ("Make
    asan_poison_object poison the whole slot"), the in-tree test suite
    now recreates this scenario[^1][^2][^3].

    Use rb_gc_pointer_to_heap_p(). Other uses of
    rb_objspace_garbage_object_p() could be making the same mistake, but
    correcting them might introduce serious performance regressions, so
    leave them alone for now.

    [^1]: http://ci.rvm.jp/results/trunk_asan@ruby-sp1/5477412
    [^2]: http://ci.rvm.jp/results/trunk_asan@ruby-sp1/5477445
    [^3]: http://ci.rvm.jp/results/trunk_asan@ruby-sp1/5477448

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12401

    Merged-By: XrXr

commit ce849d565bf6aae8e0179fffb04eb1f665f17347
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2024-12-20 00:32:14 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-20 00:32:14 +0900

    ruby2_keywords warnings: Quote non-UTF8 method names fully

    It used to quote only part of the method name because NUL byte in
    the method terminates the C string:

    ```
    (irb)> "abcdef".encode("UTF-16LE").bytes
    => [97, 0, 98, 0, 99, 0, 100, 0, 101, 0, 102, 0]
    ```

    ```
    expected: /abcdef/
    actual: warning: Skipping set of ruby2_keywords flag for a (method not defined in Ruby)\n".
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12396

    Merged-By: XrXr

commit 7b2ae8df905d7bbc084d31a8f55cecc7e7c422b3
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-19 23:20:09 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-19 23:20:09 +0900

    [Bug #20969] Pass `assignable` from ripper

    For the universal parser, `rb_reg_named_capture_assign_iter_impl`
    function is shared between the parser and ripper.  However
    `parser_params` struct is partially different, and `assignable`
    function depends on that part indirectly.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12400

commit a58675386c10f4183116056bc0cf289548883ac0
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-19 02:01:09 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-19 23:14:34 +0900

    Prefix asan_poison_object with rb

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12385

commit fcd44eee09f0a26c7711732bc8782fb8afa924f2
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-19 00:19:07 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-19 23:14:34 +0900

    Fix compaction in ASAN with RGENGC_CHECK_MODE enabled

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12385

commit a72717675f0ddaa07127ea2fa25b7c1e271fdbce
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-14 03:46:29 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-19 23:14:34 +0900

    Export asan_poison_object

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12385

commit 16750a47d0718e82818020233ed3258f8ac74aad
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-14 03:43:30 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-19 23:14:34 +0900

    Don't calculate the aligned slot when unlocking page

    If we try to use GET_PAGE_HEADER, it can trigger the read barrier. If we
    try to align on the slot then we end up unlocking the heap page of a
    lower memory address.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12385

commit f02e31294c8159239f656379ccbb34e466c0ab43
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-12 04:09:22 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-19 23:14:34 +0900

    Don't unpoison a NULL object

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12385

commit a1265601960a4de12ce88842bcd8f3fecdf3660c
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-12 02:58:05 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-19 23:14:34 +0900

    Unpoison memory before accessing next element of freelist

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12385

commit c37bdfa5311be0aa8503b995299fb9547cede0a6
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-12 02:18:00 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-19 23:14:34 +0900

    Make asan_poison_object poison the whole slot

    This change poisons the whole slot of the object rather than just the flags.
    This allows ASAN to find any reads/writes into the slot after it has been
    freed.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12385

commit ccded855b6bb2d9ab268c139f8241dcac410155f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-19 21:18:24 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 21:18:24 +0900

    Fixed label typo

commit 40af25d7fe408b657299fc11dbc6738cbc1fe59d
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2024-12-19 05:16:04 +0900
  Commit:     Stan Lo <stan.lo@shopify.com>
  CommitDate: 2024-12-19 20:58:49 +0900

    Fix bundled gems' indentations and link to their repos

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12390

commit b009f94747c8e5eb6988216facae978e6b10c7d8
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2024-12-19 04:38:36 +0900
  Commit:     Stan Lo <stan.lo@shopify.com>
  CommitDate: 2024-12-19 20:55:28 +0900

    Link to default gems' github repos

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12390

commit 7cb071c95178d236df621bddd68322a367ed604b
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2024-12-19 04:16:48 +0900
  Commit:     Stan Lo <stan.lo@shopify.com>
  CommitDate: 2024-12-19 20:52:44 +0900

    Fix release entries' indentation

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12390

commit 46fec0f62a1803d44edb8b06e39ac0f358e56670
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-19 16:12:16 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-19 16:12:16 +0900

    [Bug #20965] Define `it` like an ordinary argument (#12398)

    Also fixes [Bug #20955]

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 2783868de27113040fbfb5401325852fd12fbcd2
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-19 13:44:56 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 13:44:56 +0900

    Update NEWS.md with debug-1.10.0

commit a945c87aa8427e151b4b9329d797af8ce7235b3c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-19 13:18:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 13:18:11 +0900

    Update with logger-1.6.4

commit 0275cc0524dc343ed06436226c711e00c10dd182
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-19 13:15:55 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 13:16:56 +0900

    [ruby/logger] v1.6.4

    https://github.com/ruby/logger/commit/216cedef7c

commit d16b043cdd39d7ee8d9570798ef42cd9afc4a6f1
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-19 12:36:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 13:16:50 +0900

    [ruby/logger] Use `__FILE__` for wasm

    `/dev/null` is not available on wasm.

    https://github.com/ruby/logger/commit/4be05c2208

commit 68e2022b5b23935db6e02e18270c6fb830945b17
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-19 11:50:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 12:20:22 +0900

    The test of net-imap is passed with Windows

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12397

commit efc26d20357360e6a3265c8c6a65772af697dda1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-19 08:15:19 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 08:45:31 +0900

    Added the latest versions of irb, json and rdoc to NEWS

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12394

commit 91efe7b64f7ff6f67b8c270d37db50590af3a979
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2024-12-19 01:58:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 08:45:31 +0900

    [ruby/json] Release 2.9.1

    https://github.com/ruby/json/commit/f745ec145e

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12394

commit 979b19b741b30b7e6f0bece5d11e9668297d2cd9
  Author:     Naohisa Goto <ngotogenome@gmail.com>
  AuthorDate: 2024-12-19 01:20:40 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 08:45:31 +0900

    [ruby/json] Add support for Solaris 10 which lacks strnlen()

    Check for existence of strnlen() and use alternative code if it is missing.

    https://github.com/ruby/json/commit/48d4bbc3a0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12394

commit bba66f94f24701ea22741196beaedc81ed19789e
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2024-12-18 18:51:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 08:45:31 +0900

    [ruby/rdoc] Bump version to v6.10.0

    https://github.com/ruby/rdoc/commit/2b79892ab4

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12394

commit a920808c4bf1bfa802d46c86993adfd7313459d4
  Author:     James Reid-Smith <james.reidsmith@shopify.com>
  AuthorDate: 2024-12-18 09:07:30 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 08:45:31 +0900

    [ruby/rdoc] Auto-hide navigation on link click
    (https://github.com/ruby/rdoc/pull/1238)

    Hide navigation sidebar when clicking anchor links on mobile devices.
    Previously, anchor links would change the page but the navigation
    sidebar would block the view.

    https://github.com/ruby/rdoc/commit/f12a96b7fa

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12394

commit 35ff04ce5ee3f4758fbde1ff2940161b02b05527
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2024-12-18 19:20:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-19 08:45:31 +0900

    [ruby/irb] Bump version to v1.14.3
    (https://github.com/ruby/irb/pull/1050)

    https://github.com/ruby/irb/commit/49050f9bf3

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12394

commit c194b26132eb7babe8a98d3fc61b9a8ac15a23d0
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2024-12-19 05:58:29 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2024-12-19 06:52:11 +0900

    debug v1.10.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12392

commit 173ae93e56c62e5cf178d403ae8abcc1b125306d
  Author:     Victor Shepelev <zverok.offline@gmail.com>
  AuthorDate: 2024-12-19 04:38:40 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-19 04:38:40 +0900

    Document 'it' and update numbered parameters docs (#12375)

  Notes:
    Merged-By: zverok <zverok.offline@gmail.com>

commit 477c505ac0d4d23a860ffafbb487f7598aa89ca3
  Author:     tomoya ishida <tomoyapenguin@gmail.com>
  AuthorDate: 2024-12-19 02:08:15 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-19 02:08:15 +0900

    [DOC] Fix output examples containing old Hash#inspect format

    The inspect format was intentionally changed as an outcome of
    [Bug #20433] [ruby-core:118668], but some documentation update
    was missing, as [Bug #20962] pointed out. Update some output
    examples that clearly use Hash#inspect.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12384

    Merged-By: XrXr

commit 528ec7060464d30359e593055df6b53362cd1060
  Author:     Naohisa Goto <ngotogenome@gmail.com>
  AuthorDate: 2024-12-18 23:37:22 +0900
  Commit:     Naohisa Goto <ngotogenome@gmail.com>
  CommitDate: 2024-12-18 23:37:22 +0900

    use RBIMPL_ATTR_MAYBE_UNUSED

    The macro MAYBE_UNUSED, prepared by ./configure, may not be defined in
    some environments such as Oracle Developer Studio 12.5 on Solaris 10.

    This fixes [Bug #20963]

commit d07aa670b4e38c1e7bb17c42ebf86a8012b0f987
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-18 21:49:37 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-18 21:49:37 +0900

    Get rid of duplicate modifier for MSVC

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12383

commit 8417d09f9381c93352fe2cddbdfd4144b5924979
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-18 17:14:39 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 17:14:54 +0900

    Removed unnecessary sentence for stdlib

commit dd1208afa7b8012edaabc26cc4d2366c0d0d8139
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-18 16:31:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 16:45:10 +0900

    Extract auto-update workflow for default gems on NEWS.md

    We should stop it until final release of Ruby.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12381

commit 647449fc91c9d37752b09ac5f0a7859deee9e70e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-18 14:36:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 14:41:51 +0900

    Update description for default and bundled gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12380

commit 96ae73e72232deaafd7a1f28b36f040da916b270
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-18 14:22:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 14:41:51 +0900

    Restore rake-13.2.0 and added bundled versions of Ruby 3.3

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12380

commit d80b466a04047c3ca37dfa6837a69b7f8d313016
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-18 13:07:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 14:41:51 +0900

    Added version histories of updated default gems for Ruby 3.4

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12380

commit 6336431a64cac606ed8fa35ed577ba37755eccfc
  Author:     Alan Wu <alanwu@ruby-lang.org>
  AuthorDate: 2024-12-18 11:50:00 +0900
  Commit:     Alan Wu <alanwu@ruby-lang.org>
  CommitDate: 2024-12-18 11:50:00 +0900

    [DOC] rb_id2name(): Note truncation danger (+minor copyediting)

    Thanks, nobu!

commit 827acccce7265538bb632f001eca90a050874bd8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-18 11:22:06 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 11:22:13 +0900

    Skip to sync lib/irb/.document

commit 57f6329ba7aa744101efe026bea0a0bd46c77fc8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-13 11:52:19 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2024-12-18 11:12:34 +0900

    Check RUBY_THREAD_TIMESLICE value

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12328

commit c07fb791504cdfa32ff1be165758fcc624b26c2d
  Author:     Yusuke Endoh <mame@ruby-lang.org>
  AuthorDate: 2024-11-29 02:38:49 +0900
  Commit:     Yusuke Endoh <mame@ruby-lang.org>
  CommitDate: 2024-12-18 11:10:05 +0900

    Avoid file descriptor leak

    `extra_fd` was leaked if `fd_set_cloexec` fails -- I can't think of any
    chance of that happening here, but just in case.

    Coverity Scan found this issue.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12201

commit 25602421fb1f451746e25cc1a80b815a556be4a2
  Author:     Kouhei Yanagita <yanagi@shakenbu.org>
  AuthorDate: 2024-12-12 16:10:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 11:00:36 +0900

    [DOC] Fix the block parameter name in Array#zip

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12316

commit 3edbf6cfc5dba4da62ac23af5f0ebbbd61c8451a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-18 10:13:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 10:27:03 +0900

    [ruby/psych] Bump up v5.2.2

    https://github.com/ruby/psych/commit/746e1ad24d

commit b3abdd4cf45f370d763f6782db46c8ada5818a44
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-17 05:26:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 10:05:21 +0900

    Bump Rubygems version to 3.6.1

commit 64b8e2da6822273a059158138d3bb03ca8975547
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-17 05:26:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 10:05:21 +0900

    Bump Bundler version to 2.6.1

commit 559e9fe9905ec86374d23c1c74f79099df631427
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-17 03:23:27 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 10:05:21 +0900

    Bump vendored securerandom to 0.4.1

commit b9ad8fa52454e0dc7db2a4a617daecf5fa7d5bdb
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-17 03:18:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-18 10:05:21 +0900

    Bump vendored timeout to 0.4.3

commit 498d6eb114c52bd16a6821029959e88ed8f87396
  Author:     Misaki Shioi <31817032+shioimm@users.noreply.github.com>
  AuthorDate: 2024-12-18 09:48:26 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-18 09:48:26 +0900

    Wrap `do_fast_fallback_getaddrinfo` with `rb_thread_prevent_fork` (#12366)

    Wrap `do_fast_fallback_getaddrinfo` with `rb_thread_prevent_fork`

    Referencing PR #10864,
    wrap `do_fast_fallback_getaddrinfo` with `rb_thread_prevent_fork`
    to avoid fork safety issues.

    `do_fast_fallback_getaddrinfo` internally uses getaddrinfo(3),
    leading to fork safety issues, as described in PR #10864.
    This change ensures that `do_fast_fallback_getaddrinfo`
    is guarded by `rb_thread_prevent_fork`,
    preventing fork during its execution and avoiding related issues.

  Notes:
    Merged-By: shioimm <shioi.mm@gmail.com>

commit 98bf912d4b88169bf953a290d96fa7f556ad0589
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-18 08:48:01 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-18 08:48:01 +0900

    [DOC] Added references of github releases for bundled gems (#12365)

    * Added references of github releases for bundled gems

    * Removed bundled version of 3.3.0 and maintenance releases

    * Added history of racc, mutex_m, bigdecimal, drb, syslog and csv

    * Added test-unit, rss, net-ftp, prime and nkf.

    * Added power_assert 2.0.4

    * Removed unnecessary version of Rake

    * Update NEWS.md

    Co-authored-by: Stan Lo <stan001212@gmail.com>

    ---------

    Co-authored-by: Stan Lo <stan001212@gmail.com>

  Notes:
    Merged-By: hsbt <hsbt@ruby-lang.org>

commit fef8ecc708e0dbb5725abb1aa24329cf612f8c41
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-18 06:48:27 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-18 06:48:31 +0900

    [ruby/rdoc] Enable cross reference in code
    (https://github.com/ruby/rdoc/pull/1240)

    Some people like to mark up method names in MarkDown style block
    quotes, like this: [ruby/ruby#12333](https://github.com/ruby/ruby/pull/12333).
    Currently, no links are created in the code in the RDoc, but such
    words most likely refer to methods.
    This PR makes a word a code cross-reference if the whole word can be
    resolved as a reference.

    https://github.com/ruby/rdoc/commit/7d7efb0709

commit 375fec7c53c5b32f85c05f759c080678d29a9a94
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-18 05:06:43 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-18 06:32:13 +0900

    [DOC] Add note to rb_id2name about GC compaction

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12376

commit 1254850a616b0af57b11c2d744af1ce9988aa5e7
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2024-12-18 06:23:53 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-18 06:23:56 +0900

    [ruby/rdoc] Update tests for ruby/rdoc#1247
    (https://github.com/ruby/rdoc/pull/1248)

    https://github.com/ruby/rdoc/commit/94b9858000

commit 408f5368908889e1af141b05d3afd8704b0ef33a
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2024-12-18 05:56:21 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-18 05:56:24 +0900

    [ruby/rdoc] `aligns` may include `:center`
    (https://github.com/ruby/rdoc/pull/1247)

    https://github.com/ruby/rdoc/commit/cbbf04d6f8

commit 9715131c32fa9753da6a616c9ad3891e27bcff5b
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2024-12-18 01:34:19 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-18 03:01:39 +0900

    [DOC] Fix example in Numeric#to_int

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12372

commit 6bf7a1765f89561155eb12148ea1985e82ba8600
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2024-12-18 02:32:42 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-18 02:32:42 +0900

    YJIT: Load registers on JIT entry to reuse blocks (#12355)

  Notes:
    Merged-By: maximecb <maximecb@ruby-lang.org>

commit 0b2f034208a1131900257a7923a71bf4e3b56a3e
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-18 00:28:08 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-18 02:28:18 +0900

    [rubygems/rubygems] Fix missing `Gem::Uri.redact` on some Ruby 3.1 versions

    Our CI did not catch this because it was testing with Ruby 3.1 patch
    levels that include a RubyGems version that already has
    `Gem::Uri.redact`.

    We should make sure the system-rubygems workflow always tests against
    the oldest supportted Ruby/RubyGems combination.

    https://github.com/rubygems/rubygems/commit/3b695e3be1

commit 707c6420b1ea599c223a17781185c0b6fb0f3518
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-17 23:27:11 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-18 01:03:38 +0900

    Don't reference update frames with VM_FRAME_MAGIC_DUMMY

    Frames with VM_FRAME_MAGIC_DUMMY pushed by rb_vm_push_frame_fname have
    allocated iseq, so we should not reference update it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12371

commit 429b867d1b2de9dcdd558b13c3c9ab54e94e5a9b
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-17 00:50:14 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-18 01:03:38 +0900

    Fix autoload_table_compact

    The keys are IDs, so we cannot update references on them.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12371

commit 9733304d6112ca3ac81b70dfecf7b2b7f63beff5
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-17 00:49:49 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-18 01:03:38 +0900

    Assert Ruby object in rb_gc_location

    rb_gc_location doesn't check that the object is actually a Ruby object
    and only checks if the object looks like a T_MOVED. This may have unexpected
    outcomes if the object is not a Ruby object (e.g. a piece of malloc memory
    may be corrupted).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12371

commit 50a67820fbbb9347b3d659502bca80b0b921eeb2
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2024-12-18 00:55:43 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-18 00:55:43 +0900

    [DOC] Change arg names from n to count (#12288)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 86cf18e01e8be1db6194b7cb27357150998d9056
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2024-12-17 21:13:20 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2024-12-18 00:13:53 +0900

    [PRISM] Recurse use_deconstructed_cache in Alternation Nodes

    This fixes the behavioural difference between Prism and parse.y when
    evaluating the following code

    ```ruby
    1 in [1 | [1]]
    ```

    Fixes [Bug #20956]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12370

commit c25dd4ee472e1516be64b9b2f0a9e222ef7532d6
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-17 14:55:08 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-17 20:25:06 +0900

    Win32: Add coroutine for mswin on arm64

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12367

commit e4a4dea2c0b67048ec73f36e8dac3c637249119e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-13 14:49:04 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-17 20:25:06 +0900

    Win32: Fix the macro for arm64 on mswin

    Visual C defines `_M_`-prefixed macros for the target architectures.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12367

commit 5a7a1a4a13ae11e4cef274c98e0c5bbcb7b1d192
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-13 14:45:49 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-17 20:25:06 +0900

    Win32: Fix `rbimpl_size_mul_overflow` on arm64

    `_umul128` is specific to x86_64 platform, see higher words by
    `__umulh` on arm64.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12367

commit 36c36d0486b0c884759c038ceaf4aa495785996a
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-11-13 14:44:56 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-17 20:25:05 +0900

    Win32: Allow arm64 platform

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12367

commit a652d8b6807a9b81a4fe9bad519840c732896eea
  Author:     Naoto Ono <onoto1998@gmail.com>
  AuthorDate: 2024-12-17 18:28:04 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-17 18:28:04 +0900

    Launchable: Start recording test-spec in compilers.yaml (#12364)

  Notes:
    Merged-By: ono-max <onoto1998@gmail.com>

commit c5c88def57b580b4e7ec259dc21469d6690f04e0
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-17 15:53:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-17 15:55:55 +0900

    Update bundled_gems

commit ce72d1448728e47d0c9dee99acba08413bec186c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-17 15:48:25 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-17 15:48:33 +0900

    [ruby/win32ole] Bump up v1.9.1

    https://github.com/ruby/win32ole/commit/3e9b3b02e9

commit fc38023d4e4f44ce1d4d7c1e7921668b52983452
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-17 15:47:40 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-17 15:47:52 +0900

    [ruby/tmpdir] Bump up v0.3.1

    https://github.com/ruby/tmpdir/commit/0245079c24

commit 20ce09e0b8ceff2a4a71f5328e11905cfc44951c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-17 14:13:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-17 14:13:04 +0900

    Move Refinement#refined_class changes to Compatibility issues section

commit ef09d2dfdd0fcf152c24f6442a5bd637327e187d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-17 13:31:01 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-17 13:31:01 +0900

    Added JSON entry

commit 9a5290249047ce7182f8cfcbade8f5c94d162954
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-17 12:32:21 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-17 12:35:59 +0900

    Added YJIT entries from draft of release announcement

commit 9f0b84ee45524dcd6b3acf32137661ebd9a437d1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-17 12:10:33 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-17 12:25:00 +0900

    Added changes of RubyGems-3.6.x and Bundler-2.6.x to NEWS.md

commit c7a638747ae4c2cf7eee17b07e782b1ee446ec82
  Author:     Soutaro Matsumoto <matsumoto@soutaro.com>
  AuthorDate: 2024-12-17 11:58:00 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-17 11:58:00 +0900

    Fix constant documents (#12357)

    Delete duplicated `Document-const:` directives

    Those directives are attached to `rb_define_const` and `rb_file_const` where we don’t need them because the functions are supported by RDoc.

commit b6973e4ffc8b762d2395470082179109f5bb2374
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-12-17 10:10:26 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2024-12-17 10:10:26 +0900

    [Bug #20951] [DOC] UTC offset in `utc_to_local`

commit 187b8fdb6990145210ef6394ca8d866c2f885854
  Author:     Lars Kanis <lars@greiz-reinsdorf.de>
  AuthorDate: 2024-12-17 05:02:50 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2024-12-17 09:46:27 +0900

    Fix coroutine implementaion on Windows-Arm64

    When setjmp/longjmp/exceptions are used on Windows it's necessary to store+restore additional information from the TEB.
    I didn't find any official documentation about the values to be saved, but found the corresponding boost/context implemenataion:
        https://github.com/boostorg/context/commit/abf8e04e23cf05a499594e674d1c90db39117662

    This is similar to the special TIB handling on x86/x86_64 on Windows.

    Without this fix an exception in a fiber segfaults without any output:
      ruby -e "Fiber.new{ raise 'test' }.resume"

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12363

commit 047a87bd7a8d24afa36cc6533868dc65c9198948
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-14 01:30:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-17 09:39:03 +0900

    Bump Rubygems version to 3.6.0

commit 11910b26063e3f2d4adabddaf833262f6d537475
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-14 01:30:41 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-17 09:38:45 +0900

    Bump Bundler version to 2.6.0

commit 535f0746edf15792987d43b6ddb8e914c1e9b9d7
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2024-12-17 09:32:38 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-17 09:32:38 +0900

    Fix indent rule by rubygems/bundler cops

commit d42fcda00201a8f98a226225700b896b50e9c267
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-13 23:33:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-17 09:22:17 +0900

    Bump vendored resolv to 0.6.0

commit 2eee7a52e1d3ad5b623829784453a06c78efadef
  Author:     Alan Wu <alanwu@ruby-lang.org>
  AuthorDate: 2024-12-17 08:43:41 +0900
  Commit:     Alan Wu <alanwu@ruby-lang.org>
  CommitDate: 2024-12-17 08:43:41 +0900

    Export __asan_default_options for GCC

    Unlike Clang 15, GCC 11 seems require default symbol visibility.

commit 2102fe32ff8191ad51001daf57a1ed09a1ebc824
  Author:     Alan Wu <alanwu@ruby-lang.org>
  AuthorDate: 2024-12-17 07:11:36 +0900
  Commit:     Alan Wu <alanwu@ruby-lang.org>
  CommitDate: 2024-12-17 07:11:36 +0900

    Detect ASAN when using older GCC versions

    Newer GCCs have __has_feature and older ones have
    __SANITIZE_ADDRESS__[1]. Relevant since ASAN with GCC 11 on the popular
    Ubuntu Jammy failed to build previously.

    [1]: https://gcc.gnu.org/onlinedocs/gcc-4.8.0/cpp/Common-Predefined-Macros.html

commit 0a99daa3216c298695a5fc595fc772ebc5d1834c
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2024-12-17 06:53:33 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-17 06:53:33 +0900

    Update bundled gems list as of 2024-12-16

commit b72e8ab816b51f23c573535eb9df68c8022d7260
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2024-12-17 06:44:34 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2024-12-17 06:44:34 +0900

    Add back summary table for pack/unpack directives (#12349)

    * Add back summary table for pack/unpack directives
    * This concise summary is very helpful e.g. to find the right Integer
      directive, and is much better at getting an overview than very long text.
    * From https://github.com/ruby/ruby/pull/6567
    * I merged the tables for Array#pack and String#unpack,
      there were almost the same except for String and Misc. directives.
    * Tune up the tabular data and moves it to the top.

    Co-authored-by: Burdette Lamar <BurdetteLamar@Yahoo.com>
    Co-authored-by: Stan Lo <stan001212@gmail.com>

  Notes:
    Merged-By: eregon <eregontp@gmail.com>

commit 09dc63526ea4cbebaaadbf80782a73722bb263b6
  Author:     tompng <tomoyapenguin@gmail.com>
  AuthorDate: 2024-12-17 03:02:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2024-12-17 06:41:59 +0900

    Bundle repl_type_completor 0.1.9

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12361

commit 5ff1c479d6953c169cdc7348fd1b621d53f33c87
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2024-12-17 04:59:01 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2024-12-17 06:00:49 +0900

    Sync net-http commits

    https://github.com/ruby/net-http/commit/9bcf818fd009eafb11107c7457aa56d533d16d94
    https://github.com/ruby/net-http/commit/5e34e74261f40f4f10c93d7700761c437117f494

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12362

commit cf711863cbe0b81be5ff0adfb64936137995cc4e
  Author:     Stan Lo <stan.lo@shopify.com>
  AuthorDate: 2024-12-13 08:39:24 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2024-12-17 04:55:33 +0900

    Exclude irb from documentation generation

    - IRB has its own documentation in the project readme and https://ruby.github.io/irb/ already.
    - As a tool, its internal implementation details are not relevant to the user.
    - Excluding it from the documentation generation reduces the size of the generated documentation
      and makes search results more relevant.

    I also checked the there are no references to IRB so it should not break any links.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12325

commit 29d3ea1e84d44335d998cadaf7cf3b45270a962e
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-14 03:17:40 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-17 04:51:16 +0900

    [rubygems/rubygems] Fix `bundle lock --add-checksums` when gems are already installed

    https://github.com/rubygems/rubygems/commit/a087c452ad

commit a6fd6cb72f22531cc3cc976de99c5f9eccbf7101
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2024-12-17 04:34:56 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-17 04:35:00 +0900

    [ruby/rdoc] Print warnings for rdoc-ref links that can't be resolved
    (https://github.com/ruby/rdoc/pull/1241)

    https://github.com/ruby/rdoc/commit/4a5206ae56

commit 80b8feb929be08bd718518a57d2b549c8dab80b3
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-17 01:07:33 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-17 03:32:35 +0900

    Don't directly use rb_gc_impl_location in gc.c

    Use the wrapper gc_location_internal instead that checks for special
    constants.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12359

commit d28368d27f6ee8e82dc293f10cbbcbe7f07fa9d1
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-17 01:02:12 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-17 03:32:35 +0900

    Move special constant check in rb_gc_location to gc.c

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12359

commit d0968b1b4c402a355f207db10abbb067ee3d3377
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-13 01:42:02 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-17 03:09:54 +0900

    [rubygems/rubygems] Fix `gem info` tagging some non default gems as default

    https://github.com/rubygems/rubygems/commit/7585825c57

commit c4d35040f4720b02856daaea4d4580aeda0af268
  Author:     David Rodríguez <deivid.rodriguez@riseup.net>
  AuthorDate: 2024-12-13 01:41:50 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-17 03:09:54 +0900

    [rubygems/rubygems] Improve indentation of a `gem info` test

    https://github.com/rubygems/rubygems/commit/b0a092dac3

commit 516a6cd1ad620b880651c1333bd856a9d7dec3c4
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2024-12-17 01:41:41 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2024-12-17 02:24:24 +0900

    Check whether object is valid in allocation_info_tracer_compact

    When reference updating ObjectSpace.trace_object_allocations, we need to
    check whether the object is valid or not because it does not mark the
    object so the object may be dead. This can cause a segmentation fault
    if the object is on a free heap page.

    For example, the following script crashes:

        require "objspace"

        objs = []
        ObjectSpace.trace_object_allocations do
          1_000_000.times do
            objs << Object.new
          end
        end

        objs = nil

        # Free pages that the objs were on
        GC.start

        # Run compaction and check that it doesn't crash
        GC.compact

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12360

commit 9b3831e90831b8410040f4c064abfcc61626e061
  Author:     Mari Imaizumi <mariimaizumi5@gmail.com>
  AuthorDate: 2024-12-17 02:10:23 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2024-12-17 02:10:27 +0900

    [ruby/reline] Bump version to 0.6.0
    (https://github.com/ruby/reline/pull/795)

    https://github.com/ruby/reline/commit/e0850cd5ba

commit db78ab5ed278e0e3e73fe9142d15415a0fc8e3a1
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2024-10-02 04:06:17 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2024-12-17 00:51:22 +0900

    [ruby/prism] Update src/prism.c

    https://github.com/ruby/prism/commit/544df5835f

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12358

commit f6e0a037aa21bd90830cecc397c16918890d76a2
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2024-12-04 15:32:55 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2024-12-17 00:51:22 +0900

    [ruby/prism] [Bug #20785] Allow `, and` and `, or`  after patterns

    Partially: https://bugs.ruby-lang.org/issues/20785

    https://github.com/ruby/prism/commit/71c9102d02

  Notes:
    Merged: https://github.com/ruby/ruby/pull/12358

